package io.reisub.openosrs.agility;

import net.runelite.client.plugins.iutils.scene.Position;

public enum Course {
    SEERS_VILLAGE(
            new ObstacleArea(2704,2733,3456,3495,0,14927),
            new ObstacleArea(2721,2730,3490,3497,3,14928),
            new ObstacleArea(2704,2714,3487,3497,2,14932),
            new ObstacleArea(2709,2716,3476,3482,2,14929),
            new ObstacleArea(2700,2715,3470,3475,3,14930),
            new ObstacleArea(2690,2703,3459,3466,2,14931)
    ),
    POLLNIVNEACH(
            new ObstacleArea(3345,3375,2957,3003,0,14935),
            new ObstacleArea(3346,3351,2963,2968,1,14936),
            new ObstacleArea(3352,3355,2973,2976,1,14937),
            new ObstacleArea(3360,3362,2977,2979,1,14938),
            new ObstacleArea(3366,3370,2974,2976,1,14939),
            new ObstacleArea(3365,3369,2982,2986,1,14940),
            new ObstacleArea(3355,3365,2980,2985,2,14941),
            new ObstacleArea(3357,3370,2990,2995,2,14944),
            new ObstacleArea(3356,3364,3000,3004,2,14945)
    ),
    RELEKKA(
            new ObstacleArea(2622,2653,3656,3682,0,14946),
            new ObstacleArea(2622,2626,3672,3676,3,14947),
            new ObstacleArea(2615,2622,3658,3668,3,14987),
            new ObstacleArea(2626,2630,3651,3655,3,14990),
            new ObstacleArea(2639,2644,3649,3653,3,14991),
            new ObstacleArea(2643,2650,3657,3662,3,14992),
            new ObstacleArea(2655,2666,3665,3685,3,14994)
    ),
    ARDOUGNE(
            new ObstacleArea(2650,2674,3293,3319,0,15608),
            new ObstacleArea(2671,2671,3299,3309,3,15609),
            new ObstacleArea(2662,2665,3318,3318,3,26635),
            new ObstacleArea(2654,2657,3318,3318,3,15610),
            new ObstacleArea(2653,2653,3310,3314,3,15611),
            new ObstacleArea(2651,2653,3300,3309,3,28912),
            new ObstacleArea(2656,2656,3297,3297,3,15612)
    );

    private final ObstacleArea[] areas;

    Course(ObstacleArea... area) {
        areas = area;
    }

    public int getNextObstacleID(Position current) {
        for (ObstacleArea area : areas) {
            if (area.contains(current)) {
                return area.getId();
            }
        }

        return 0;
    }

    public boolean markIsReachable(Position player, Position mark) {
        if (player == null || mark == null) return false;

        for (ObstacleArea area : areas) {
            if (area.contains(player) && area.contains(mark)) {
                return true;
            }
        }

        return false;
    }
}
