package io.reisub.openosrs.agility.tasks;

import io.reisub.openosrs.agility.Config;
import io.reisub.openosrs.util.Task;
import net.runelite.api.Skill;
import net.runelite.api.events.GameTick;
import net.runelite.api.events.StatChanged;
import net.runelite.api.widgets.WidgetInfo;
import net.runelite.client.plugins.iutils.api.Spells;
import net.runelite.client.plugins.iutils.game.InventoryItem;
import net.runelite.client.plugins.iutils.game.iWidget;

import javax.inject.Inject;

public class Alch extends Task {
    @Inject
    private Config config;

    private boolean ready;
    private long lastAlchTick;
    private String[] items;

    @Override
    public String getStatus() {
        return "High alching";
    }

    @Override
    public boolean validate() {
        if (items == null) {
            items = config.alchItems().split(",");
            for (int i = 0; i < items.length; i++) {
                items[i] = items[i].trim();
            }
        }

        return config.highAlch()
                && game.inventory().withName(items).exists()
                && game.inventory().withName("Nature rune").exists()
                && ready;
    }

    @Override
    public void execute() {
        ready = false;
        lastAlchTick = game.ticks();

        iWidget magicTab = game.widget(WidgetInfo.RESIZABLE_VIEWPORT_MAGIC_TAB);
        if (magicTab == null || magicTab.hidden()) {
            game.openInterface(3);
            game.tick();
        }

        InventoryItem item = game.inventory().withName(items).first();
        game.widget(Spells.HIGH_LEVEL_ALCHEMY.getInfo()).useOn(item);
        game.sleepDelay();
    }

    public void onStatChanged(StatChanged event) {
        if (event.getSkill().equals(Skill.AGILITY)) {
            ready = true;
        }
    }

    public void onGameTick(GameTick event) {
        if (game.ticks() - lastAlchTick >= 5 && game.localPlayer().position().z == 0) {
            ready = true;
        }
    }
}
