package io.reisub.openosrs.agility.tasks;

import io.reisub.openosrs.agility.Config;
import io.reisub.openosrs.util.Task;
import net.runelite.api.Skill;
import net.runelite.api.events.*;
import net.runelite.client.plugins.iutils.game.iObject;

import javax.inject.Inject;

public class HandleObstacle extends Task {
    @Inject
    private Config config;

    private boolean ready;
    private int timeout = 10;
    private int idleTicks;

    @Override
    public String getStatus() {
        return "Handling obstacle";
    }

    @Override
    public boolean validate() {
        return ready;
    }

    @Override
    public void execute() {
        int id = config.courseSelection().getNextObstacleID(game.localPlayer().position());
        if (id == 0) return;

        iObject object = game.objects().withId(id).first();
        if (object == null) return;

        game.sleepDelay();
        object.interact(object.actions().get(0));
        game.tick();

        ready = false;
    }

    public void setReady(boolean ready) {
        this.ready = ready;
    }

    public void onHitsplatApplied(HitsplatApplied event) {
        if (event.getHitsplat() != null && event.getHitsplat().isMine()) {
            timeout = calc.random(2, 3);
        }
    }

    public void onStatChanged(StatChanged event) {
        if (event.getSkill().equals(Skill.AGILITY)) {
            ready = true;
        }

        if (event.getSkill().equals(Skill.MAGIC)) {
            if (game.localPlayer().position().z == 0) {
                if (!game.localPlayer().isMoving()) {
                    ready = true;
                }

                int id = config.courseSelection().getNextObstacleID(game.localPlayer().position());
                iObject object = game.objects().withId(id).first();

                if (object != null && game.localPlayer().position().distanceTo(object.position()) < 4) {
                    ready = true;
                }
            } else {
                ready = true;
            }
        }
    }

    public void onGameTick(GameTick event) {
        if (game.localPlayer().isIdle()) {
            idleTicks++;
            if (idleTicks >= timeout) {
                ready = true;
                timeout = calc.random(7, 13);
            }
        } else {
            idleTicks = 0;
        }
    }

    public void onChatMessage(ChatMessage chatMessage) {
        if (chatMessage.getMessage().contains("Can't reach that")) {
            timeout = calc.random(1, 3);
        }

        if (chatMessage.getMessage().contains("You softly stroke your cat.")) {
            ready = true;
        }
    }

    public void onConfigButtonPressed(ConfigButtonClicked configButtonClicked) {
        if (configButtonClicked.getKey().equals("startButton")) {
            ready = true;
        }
    }
}
