package io.reisub.openosrs.agility.tasks;

import io.reisub.openosrs.agility.Config;
import io.reisub.openosrs.util.Task;
import net.runelite.api.Skill;
import net.runelite.api.events.HitsplatApplied;
import net.runelite.api.events.StatChanged;
import net.runelite.client.plugins.iutils.game.iGroundItem;
import net.runelite.client.plugins.iutils.scene.Position;

import javax.inject.Inject;

public class PickupMark extends Task {
    @Inject
    private Config config;

    private boolean failed;

    @Override
    public String getStatus() {
        return "Picking up mark";
    }

    @Override
    public boolean validate() {
        if (failed) return false;

        iGroundItem mark = game.groundItems().withName("Mark of grace").nearest();

        Position markPos = null;
        try {
            markPos = mark.position();
        } catch (NullPointerException ignored) {}

        return mark != null
                && config.courseSelection().markIsReachable(game.localPlayer().position(), markPos);
    }

    @Override
    public void execute() {
        game.waitUntil(() -> game.localPlayer().isIdle(), 10);

        game.groundItems().withName("Mark of grace").findFirst().ifPresent(mark -> {
            mark.interact(mark.actions().get(0));
            game.tick();
        });

        game.waitUntil(() -> !game.groundItems().withName("Mark of grace").exists(), 10);
    }

    public void onHitsplatApplied(HitsplatApplied event) {
        if (event.getHitsplat() != null && event.getHitsplat().isMine()) {
            failed = true;
        }
    }

    public void onStatChanged(StatChanged event) {
        if (event.getSkill().equals(Skill.AGILITY)) {
            failed = false;
        }
    }
}
