package io.reisub.openosrs.birdhouse;

import lombok.AllArgsConstructor;
import lombok.Getter;

@AllArgsConstructor
@Getter
public enum BirdhouseState {
    SEEDED(),
    BUILT(),
    EMPTY(),
    UNKNOWN();

    public static BirdhouseState fromVarpValue(int varp) {
        if (varp < 0 || varp > BirdhouseType.values().length * 3) {
            return UNKNOWN;
        } else if (varp == 0) {
            return EMPTY;
        } else if (varp % 3 == 0) {
            return SEEDED;
        } else {
            return BUILT;
        }
    }
}
