package io.reisub.openosrs.birdhouse.tasks;

import io.reisub.openosrs.util.Task;
import net.runelite.client.plugins.iutils.game.InventoryItem;
import net.runelite.client.plugins.iutils.game.iObject;

public class AddSeeds extends Task {
    @Override
    public String getStatus() {
        return "Adding seeds to birdhouse";
    }

    @Override
    public boolean validate() {
        return game.objects().filter(iObject -> iObject.name().endsWith("(empty)")).exists();
    }

    @Override
    public void execute() {
        iObject birdhouse = game.objects().filter(iObject -> iObject.name().endsWith("(empty)")).nearest();
        InventoryItem seeds = game.inventory().withNamePart("seed").first();
        if (birdhouse == null || seeds == null) return;

        int quantity = seeds.quantity();
        seeds.useOn(birdhouse);

        game.waitUntil(() -> game.inventory().withNamePart("seed").first() == null || game.inventory().withNamePart("seed").first().quantity() < quantity, 5);
    }
}
