package io.reisub.openosrs.birdhouse.tasks;

import io.reisub.openosrs.birdhouse.Birdhouse;
import io.reisub.openosrs.util.Task;
import net.runelite.api.ItemID;
import net.runelite.client.plugins.iutils.game.InventoryItem;
import net.runelite.client.plugins.iutils.game.iObject;
import net.runelite.client.plugins.iutils.ui.Chatbox;

import javax.inject.Inject;

public class BankSpores extends Task {
    @Inject
    private Birdhouse plugin;

    @Override
    public String getStatus() {
        return "Depositing everything and withdrawing spores";
    }

    @Override
    public boolean validate() {
        return game.localPlayer().position().distanceTo(plugin.getIslandPosition()) < 10
                && game.inventory().withNamePart("nest").exists();
    }

    @Override
    public void execute() {
        for (InventoryItem nest : game.inventory().withNamePart("nest").withAction("Search").all()) {
            nest.interact("Search");
            game.tick();
        }

        if (!bank.isOpen()) {
            iObject bankObj = game.objects().withName("Bank chest", "Bank booth", "Bank Chest-wreck").nearest();
            if (bankObj == null) return;

            bankObj.interact(0);
            game.waitUntil(() -> bank.isOpen(), 15);
        }

        bank.depositInventory();
        game.tick();

        bank.withdraw(ItemID.SEAWEED_SPORE, 1, false);
        game.sleepDelay();
        bank.withdraw(ItemID.SEAWEED_SPORE, 1, false);
        game.tick();

        bank.withdraw(ItemID.FISHBOWL_HELMET, 1, false);
        game.tick();

        bank.withdraw(ItemID.DIVING_APPARATUS, 1, false);
        game.tick();

        bank.withdraw(ItemID.FLIPPERS, 1, false);
        game.tick();

        bank.close();
        game.waitUntil(() -> !bank.isOpen(), 5);

        game.inventory().withId(ItemID.FISHBOWL_HELMET).findFirst().ifPresent((helmet) -> helmet.interact("Wear"));
        game.tick();

        game.inventory().withId(ItemID.DIVING_APPARATUS).findFirst().ifPresent((apparatus) -> apparatus.interact("Wear"));
        game.tick();

        game.inventory().withId(ItemID.FLIPPERS).findFirst().ifPresent((flippers) -> flippers.interact("Wear"));
        game.tick();
        iObject rowboat = game.objects().withName("Rowboat").nearest();
        if (rowboat == null) return;

        rowboat.interact("Dive");
        game.waitUntil(() -> chatbox.chatState() == Chatbox.ChatState.OPTIONS_CHAT
                || game.localPlayer().position().regionID() == 15008, 10);

        if (chatbox.chatState() == Chatbox.ChatState.OPTIONS_CHAT) {
            chatbox.chooseOption(1);
            game.waitUntil(() -> game.localPlayer().position().regionID() == 15008, 10);
        }
        game.tick();
    }
}
