package io.reisub.openosrs.birdhouse.tasks;

import io.reisub.openosrs.birdhouse.Birdhouse;
import io.reisub.openosrs.util.Task;
import net.runelite.client.plugins.iutils.game.InventoryItem;
import net.runelite.client.plugins.iutils.game.iNPC;
import net.runelite.client.plugins.iutils.game.iObject;
import net.runelite.client.plugins.iutils.game.iWidget;

import javax.inject.Inject;

public class Deposit extends Task {
    @Inject
    private Birdhouse plugin;

    @Override
    public String getStatus() {
        return "Depositing everything";
    }

    @Override
    public boolean validate() {
        return game.localPlayer().position().regionID() == 15008
                && game.objects().withName("Seaweed").count() == 2;
    }

    @Override
    public void execute() {
        iNPC leprechaun = game.npcs().withName("Tool Leprechaun").first();
        if (leprechaun == null) return;

        leprechaun.interact("Exchange");
        game.waitUntil(() -> game.widget(125, 0) != null, 30);
        game.tick();

        iWidget dibber = game.widget(126, 2);
        if (dibber == null) return;
        dibber.interact("Store-1");
        game.tick();

        iWidget spade = game.widget(126, 3);
        if (spade == null) return;
        spade.interact("Store-1");
        game.tick();

        for (int i = 0; i < 2; i++) {
            iWidget bucket = game.widget(126, 9);
            if (bucket == null) return;
            bucket.interact("Store-1");
            game.sleepDelay();
        }
        game.tick();

        iWidget close = game.widget(125, 1, 11);
        if (close ==  null) return;
        close.interact("Close");

        game.waitUntil(() -> game.widget(125, 0) == null, 5);

        iObject rope = game.objects().withName("Anchor rope").first();
        if (rope == null) return;

        rope.interact("Climb");
        game.tick();

        if (game.inventory().withAction("Wear").exists()) {
            for (InventoryItem gear : game.inventory().withAction("Wear").all()) {
                gear.interact("Wear");
                game.tick(3);
            }

            game.tick();
            rope.interact("Climb");
        }

        game.waitUntil(() -> game.localPlayer().position().regionID() == 14908, 30);
        game.tick();

        if (!bank.isOpen()) {
            iObject bankObj = game.objects().withName("Bank chest", "Bank booth", "Bank Chest-wreck").nearest();
            if (bankObj == null) return;

            bankObj.interact(0);
            game.waitUntil(() -> bank.isOpen(), 15);
        }

        bank.depositInventory();
        game.sleepDelay();

        bank.close();
        game.tick();
    }
}
