package io.reisub.openosrs.birdhouse.tasks;

import io.reisub.openosrs.birdhouse.Birdhouse;
import io.reisub.openosrs.birdhouse.BirdhouseSpace;
import io.reisub.openosrs.birdhouse.BirdhouseState;
import io.reisub.openosrs.util.Task;
import net.runelite.client.plugins.iutils.game.iObject;

import javax.inject.Inject;
import java.time.Instant;

public class EmptyBirdhouse extends Task {
    @Inject
    private Birdhouse plugin;

    private BirdhouseSpace space = null;

    @Override
    public String getStatus() {
        return "Emptying birdhouse";
    }

    @Override
    public boolean validate() {
        space = getNext();
        if (space == null) return false;

        return game.objects().withPosition(space.getPosition()).withAction("Empty").exists();
    }

    @Override
    public void execute() {
        iObject birdhouse = game.objects().withPosition(space.getPosition()).withAction("Empty").first();
        if (birdhouse == null) return;

        birdhouse.interact("Empty");
        if (!game.waitUntil(() -> !game.objects().withPosition(space.getPosition()).withAction("Empty").exists(), 15)) return;

        plugin.getBirdhouseTimers().put(space, Instant.now());
        space = null;
    }

    private BirdhouseSpace getNext() {
        for (BirdhouseSpace space : BirdhouseSpace.values()) {
            int varp = game.client().getVar(space.getVarp());

            if (BirdhouseState.fromVarpValue(varp) == BirdhouseState.SEEDED
                    && !plugin.hasRecentlyBeenEmptied(space)) {
                return space;
            }
        }

        return null;
    }
}
