package io.reisub.openosrs.birdhouse.tasks;

import io.reisub.openosrs.birdhouse.Birdhouse;
import io.reisub.openosrs.birdhouse.BirdhouseSpace;
import io.reisub.openosrs.util.Task;
import net.runelite.client.plugins.iutils.scene.Position;

import javax.inject.Inject;

public class GoToBirdhouse extends Task {
    @Inject
    private Birdhouse plugin;

    private final Position target = new Position(3681, 3819, 0);

    @Override
    public String getStatus() {
        return "Going to southern birdhouse";
    }

    @Override
    public boolean validate() {
        return plugin.hasRecentlyBeenEmptied(BirdhouseSpace.MEADOW_NORTH)
                && !plugin.hasRecentlyBeenEmptied(BirdhouseSpace.MEADOW_SOUTH)
                && game.localPlayer().position().distanceTo(target) > 15;
    }

    @Override
    public void execute() {
        walking.walkTo(target.areaWithin(1));
    }
}
