package io.reisub.openosrs.birdhouse.tasks;

import io.reisub.openosrs.birdhouse.Birdhouse;
import io.reisub.openosrs.birdhouse.BirdhouseSpace;
import io.reisub.openosrs.birdhouse.Config;
import io.reisub.openosrs.util.Task;
import net.runelite.client.plugins.iutils.game.iObject;
import net.runelite.client.plugins.iutils.scene.Position;
import net.runelite.client.plugins.iutils.ui.Chatbox;

import javax.inject.Inject;

public class GoToIsland extends Task {
    @Inject
    private Birdhouse plugin;

    @Inject
    private Config config;

    private final Position target = new Position(3731, 3892, 0);

    @Override
    public String getStatus() {
        return "Going to northern island";
    }

    @Override
    public boolean validate() {
        for (BirdhouseSpace space : BirdhouseSpace.values()) {
            if (!plugin.hasRecentlyBeenEmptied(space)) return false;
        }

        if (!config.farmSeaweed()) return false;

        int region = game.localPlayer().position().regionID();

        return region == 14651 || region == 14652;
    }

    @Override
    public void execute() {
        walking.walkTo(target.areaWithin(1));

        iObject rowboat = game.objects().withName("Rowboat").withAction("Travel").nearest();
        if (rowboat == null) return;

        while (game.localPlayer().position().distanceTo(plugin.getIslandPosition()) > 10) {
            rowboat.interact("Travel");
            game.waitUntil(() -> chatbox.chatState() == Chatbox.ChatState.OPTIONS_CHAT, 15);

            chatbox.chooseOption(3);
            game.waitUntil(() -> game.localPlayer().position().distanceTo(plugin.getIslandPosition()) < 10, 5);
        }
        game.tick();
    }
}
