package io.reisub.openosrs.birdhouse.tasks;

import io.reisub.openosrs.util.Task;
import net.runelite.api.ItemID;
import net.runelite.client.plugins.iutils.game.iObject;

public class HarvestSeaweed extends Task {
    @Override
    public String getStatus() {
        return "Harvesting seaweed";
    }

    @Override
    public boolean validate() {
        return game.localPlayer().position().regionID() == 15008
                && game.inventory().withId(ItemID.SEED_DIBBER).exists()
                && !game.inventory().full()
                && (game.objects().withName("Dead seaweed").exists() || game.objects().withAction("Pick").withName("Seaweed").exists());
    }

    @Override
    public void execute() {
        iObject deadSeaweed = game.objects().withName("Dead seaweed").first();
        if (deadSeaweed != null) {
            int count = (int) game.objects().withName("Dead seaweed").count();
            deadSeaweed.interact("Clear");

            game.waitUntil(() -> game.objects().withName("Dead seaweed").count() < count, 30);
            return;
        }

        iObject seaweed = game.objects().withName("Seaweed").withAction("Pick").nearest();
        if (seaweed == null) return;

        int count = (int) game.objects().withName("Seaweed").withAction("Pick").count();
        seaweed.interact("Pick");
        game.waitUntil(() -> game.objects().withName("Seaweed").withAction("Pick").count() < count
                || game.groundItems().withId(ItemID.SEAWEED_SPORE).exists()
                || game.inventory().full(), 120);
        game.tick();
    }
}
