package io.reisub.openosrs.birdhouse.tasks;

import io.reisub.openosrs.util.Task;
import net.runelite.api.ItemID;
import net.runelite.client.plugins.iutils.game.InventoryItem;
import net.runelite.client.plugins.iutils.game.iObject;

public class PlantSeaweed extends Task {
    @Override
    public String getStatus() {
        return "Planting seaweed";
    }

    @Override
    public boolean validate() {
        return game.localPlayer().position().regionID() == 15008
                && game.objects().withName("Seaweed patch").exists();
    }

    @Override
    public void execute() {
        iObject patch = game.objects().withName("Seaweed patch").nearest();
        if (patch == null) return;

        InventoryItem seed = game.inventory().withId(ItemID.SEAWEED_SPORE).first();
        if (seed == null) return;

        int quantity = seed.quantity();

        seed.useOn(patch);
        game.waitUntil(() -> game.inventory().withId(ItemID.SEAWEED_SPORE).first() == null
                || game.inventory().withId(ItemID.SEAWEED_SPORE).first().quantity() < quantity, 10);
        game.tick(3);


        InventoryItem ultraCompost = game.inventory().withId(ItemID.ULTRACOMPOST).first();
        if (ultraCompost == null) return;

        patch = game.objects().withName("Seaweed").nearest();
        if (patch == null) return;

        ultraCompost.useOn(patch);
        game.tick(3);
    }
}
