package io.reisub.openosrs.blackjack.tasks;

import io.reisub.openosrs.blackjack.BlackjackConfig;
import io.reisub.openosrs.util.Task;
import lombok.Getter;
import lombok.Setter;
import net.runelite.client.plugins.iutils.game.iNPC;

import javax.inject.Inject;

public class Blackjack extends Task {
    @Inject
    private BlackjackConfig config;

    @Setter @Getter
    private volatile boolean ready;

    @Setter @Getter
    private volatile long nextKnockoutTick = 0;

    @Override
    public String getStatus() {
        return "Blackjacking";
    }

    @Override
    public boolean validate() {
        return isReady()
                && game.client().getTickCount() >= nextKnockoutTick
                && game.client().getLocalPlayer().getModelHeight() != 1000
                && game.inventory().withAction("Eat", "Drink").exists();
    }

    @Override
    public void execute() {
        iNPC target = game.npcs().withId(config.target().getId()).nearest();
        if (target == null) return;

        target.interact("Knock-Out");
        ready = false;
        game.tick();
    }
}
