package io.reisub.openosrs.blackjack.tasks;

import io.reisub.openosrs.blackjack.BlackjackConfig;
import io.reisub.openosrs.util.Task;
import lombok.Getter;
import lombok.Setter;
import net.runelite.client.plugins.iutils.game.iNPC;

import javax.inject.Inject;

public class Pickpocket extends Task {
    @Inject
    private BlackjackConfig config;

    @Setter
    private volatile boolean ready;

    @Getter
    @Setter
    private volatile int successivePickpockets = 0;

    @Override
    public String getStatus() {
        return "Pickpocketing";
    }

    @Override
    public boolean validate() {
        return ready && game.inventory().withAction("Eat", "Drink").exists();
    }

    @Override
    public void execute() {
        iNPC target = game.npcs().withId(config.target().getId()).nearest();
        if (target == null) return;

        if (getSuccessivePickpockets() == 0) {
            game.sleepDelay();
        }

        target.interact("Pickpocket");
        setSuccessivePickpockets(getSuccessivePickpockets() + 1);
        ready = false;
        game.tick();
    }
}
