package io.reisub.openosrs.cooker.tasks;

import io.reisub.openosrs.cooker.Config;
import io.reisub.openosrs.cooker.Cooker;
import io.reisub.openosrs.util.Task;
import io.reisub.openosrs.util.enums.Activity;
import net.runelite.client.plugins.iutils.game.InventoryItem;
import net.runelite.client.plugins.iutils.game.iObject;
import net.runelite.client.plugins.iutils.ui.Chatbox;

import javax.inject.Inject;

public class Cook extends Task {
    @Inject
    private Cooker plugin;

    @Inject
    private Config config;

    @Override
    public String getStatus() {
        return "Cooking";
    }

    @Override
    public boolean validate() {
        return plugin.getCurrentActivity() == Activity.IDLE
                && game.inventory().withId(config.rawFood()).exists();
    }

    @Override
    public void execute() {
        iObject oven = game.objects().withName("Clay oven").nearest();
        iObject fire = game.objects().withName("Fire").nearest();
        if (oven == null && fire == null) return;

        if (oven != null) {
            oven.interact(0);
        } else {
            InventoryItem rawFood = game.inventory().withId(config.rawFood()).first();
            if (rawFood == null) return;

            rawFood.useOn(fire);
        }
        game.waitUntil(() -> chatbox.chatState() == Chatbox.ChatState.MAKE, 20);

        if (chatbox.chatState() == Chatbox.ChatState.MAKE) {
            if (calc.random(0, 4) == 1) {
                game.sleepDelay();
            }

            int count = (int) game.inventory().withId(config.rawFood()).count();

            chatbox.make(0, count);
            game.waitUntil(() -> plugin.getCurrentActivity() == Activity.COOKING, 5);
        }
    }
}
