package io.reisub.openosrs.cooker.tasks;

import io.reisub.openosrs.cooker.Config;
import io.reisub.openosrs.util.Task;
import net.runelite.api.ItemID;
import net.runelite.client.plugins.iutils.game.iNPC;
import net.runelite.client.plugins.iutils.game.iObject;

import javax.inject.Inject;

public class HandleBank extends Task {
    @Inject
    private Config config;

    @Override
    public String getStatus() {
        return "Banking";
    }

    @Override
    public boolean validate() {
        return !game.inventory().withId(config.rawFood()).exists();
    }

    @Override
    public void execute() {
        if (!bank.isOpen()) {
            iNPC banker = game.npcs().withName("Emerald Benedict").first();
            iObject bankObj = game.objects().withName("Bank chest", "Bank booth").nearest();;
            if (banker == null && bankObj == null) return;

            if (banker != null) {
                banker.interact("Bank");
            } else {
                bankObj.interact(0);
            }
            game.waitUntil(() -> bank.isOpen(), 20);
        }

        if (game.inventory().findAny().isPresent()) {
            bank.depositInventory();
            game.tick();
            game.sleepDelay();
        }

        if (config.rawFood() == ItemID.GIANT_SEAWEED) {
            bank.withdraw(config.rawFood(), 4, false);
        } else {
            bank.withdraw(config.rawFood(), 28, false);
        }

        game.sleepDelay();
        bank.close();
        game.sleepDelay();
    }
}
