package io.reisub.openosrs.fighter.tasks;

import io.reisub.openosrs.fighter.Fighter;
import io.reisub.openosrs.util.Task;
import io.reisub.openosrs.util.enums.Activity;
import net.runelite.client.plugins.iutils.actor.NpcStream;
import net.runelite.client.plugins.iutils.game.iNPC;

import javax.inject.Inject;
import java.util.stream.Stream;

public class Fight extends Task {
    @Inject
    private Fighter plugin;

    @Override
    public String getStatus() {
        return "Fighting";
    }

    @Override
    public boolean validate() {
        if (plugin.getCurrentActivity() != Activity.IDLE) return false;

        NpcStream idStream = game.npcs().withId(plugin.getTargetIds()).withoutTarget();
        NpcStream nameStream = game.npcs().withName(plugin.getTargetNames()).withoutTarget();

        NpcStream targetStream = (NpcStream) Stream.concat(idStream, nameStream);

        if (plugin.getConfig().usePathfinding()) {
            plugin.setCurrentTarget(targetStream.within(plugin.getConfig().pathfindingSearchRadius()).nearestPath());
        }

        if (plugin.getCurrentActivity() == null) {
            plugin.setCurrentTarget(targetStream.within(plugin.getConfig().searchRadius()).nearest());
        }

        return plugin.getCurrentTarget() != null;
    }

    @Override
    public void execute() {
        if (plugin.getCurrentTarget() == null) return;

        plugin.getCurrentTarget().interact(0);
        game.waitUntil(() -> game.localPlayer().target() != null && game.localPlayer().target().name().equals(plugin.getCurrentTarget().name()), 15);
    }
}
