package io.reisub.openosrs.fisher;

import com.google.inject.Provides;
import io.reisub.openosrs.fisher.tasks.Drop;
import io.reisub.openosrs.fisher.tasks.Fish;
import io.reisub.openosrs.util.CScript;
import io.reisub.openosrs.util.Util;
import lombok.extern.slf4j.Slf4j;
import net.runelite.client.config.ConfigManager;
import net.runelite.client.plugins.PluginDependency;
import net.runelite.client.plugins.PluginDescriptor;
import net.runelite.client.plugins.iutils.iUtils;
import org.pf4j.Extension;

@Extension
@PluginDependency(Util.class)
@PluginDependency(iUtils.class)
@PluginDescriptor(
	name = "Chaos Fisher",
	description = "Frantically fishes fish",
	enabledByDefault = false
)
@Slf4j
public class Fisher extends CScript {
	@Provides
	Config provideConfig(ConfigManager configManager) {
		return configManager.getConfig(Config.class);
	}

	@Override
	protected void onStart() {
		super.onStart();

		addTask(Drop.class);
		addTask(Fish.class);
	}
}