package io.reisub.openosrs.fisher.tasks;

import io.reisub.openosrs.util.Task;
import net.runelite.api.GameState;
import net.runelite.api.World;
import net.runelite.api.WorldType;
import net.runelite.client.plugins.iutils.game.iNPC;

import java.util.EnumSet;
import java.util.LinkedList;
import java.util.Queue;

public class Hop extends Task {
    private Queue<World> worlds;

    @Override
    public String getStatus() {
        return "Hopping";
    }

    @Override
    public boolean validate() {
        iNPC spot = game.npcs().filter(iNPC -> iNPC.name().equals("Rod Fishing spot")  && iNPC.position().x > 2850 && iNPC.position().y <= 2974).nearest();

        return spot == null && !game.inventory().full();
    }

    @Override
    public void execute() {
        game.client().hopToWorld(getNextWorld());
        game.sleepApproximately(3000);

        game.waitUntil(() -> game.client().getGameState() == GameState.LOGGED_IN);
    }

    private World getNextWorld() {
        if (worlds == null) {
            generateWorldsQueue();
        }

        World w = worlds.poll();
        worlds.add(w);

        return w;
    }

    private void generateWorldsQueue() {
        worlds = new LinkedList<>();

        for (World w : game.client().getWorldList()) {
            EnumSet<WorldType> types = w.getTypes();

            if (types.contains(WorldType.MEMBERS)
                    && !types.contains(WorldType.BOUNTY)
                    && !types.contains(WorldType.TOURNAMENT_WORLD)
                    && !types.contains(WorldType.DEADMAN)
                    && !types.contains(WorldType.HIGH_RISK)
                    && !types.contains(WorldType.LAST_MAN_STANDING)
                    && !types.contains(WorldType.NOSAVE_MODE)
                    && !types.contains(WorldType.SEASONAL)
                    && !types.contains(WorldType.PVP)) {
                worlds.add(w);
            }
        }
    }
}
