package io.reisub.openosrs.glassblower;

import com.google.inject.Provides;
import io.reisub.openosrs.glassblower.tasks.Blow;
import io.reisub.openosrs.glassblower.tasks.HandleBank;
import io.reisub.openosrs.glassblower.tasks.PickupSeed;
import io.reisub.openosrs.util.CScript;
import io.reisub.openosrs.util.Util;
import io.reisub.openosrs.util.enums.Activity;
import lombok.extern.slf4j.Slf4j;
import net.runelite.api.AnimationID;
import net.runelite.api.GameState;
import net.runelite.api.Skill;
import net.runelite.api.events.AnimationChanged;
import net.runelite.client.config.ConfigManager;
import net.runelite.client.eventbus.Subscribe;
import net.runelite.client.plugins.PluginDependency;
import net.runelite.client.plugins.PluginDescriptor;
import net.runelite.client.plugins.iutils.iUtils;
import org.pf4j.Extension;

@Extension
@PluginDependency(Util.class)
@PluginDependency(iUtils.class)
@PluginDescriptor(
	name = "Chaos Glassblower",
	description = "Huffs and puffs",
	enabledByDefault = false
)
@Slf4j
public class Glassblower extends CScript {
	public static final int FOSSIL_ISLAND_SMALL_ISLAND_REGION = 14908;
	public static final int FOSSIL_ISLAND_SEAWEED_REGION = 15008;

	@Provides
	Config provideConfig(ConfigManager configManager) {
		return configManager.getConfig(Config.class);
	}

	@Override
	protected void onStart() {
		super.onStart();

		idleCheckSkills.put(Skill.CRAFTING, Activity.GLASSBLOWING);

		addTask(PickupSeed.class);
		addTask(HandleBank.class);
		addTask(Blow.class);
	}

	@SuppressWarnings("unused")
	@Subscribe
	private void onAnimationChanged(AnimationChanged event) {
		if (game.client().getGameState() != GameState.LOGGED_IN) return;
		if (event.getActor() != game.client().getLocalPlayer()) return;


		int animId = game.localPlayer().animation();
		switch (animId) {
			case AnimationID.CRAFTING_GLASSBLOWING:
				setActivity(Activity.GLASSBLOWING);
				break;
		}
	}
}