package io.reisub.openosrs.glassblower.tasks;

import io.reisub.openosrs.glassblower.Config;
import io.reisub.openosrs.glassblower.Glassblower;
import io.reisub.openosrs.util.Task;
import io.reisub.openosrs.util.enums.Activity;
import net.runelite.api.ItemID;
import net.runelite.client.plugins.iutils.game.InventoryItem;
import net.runelite.client.plugins.iutils.game.iObject;
import net.runelite.client.plugins.iutils.ui.Chatbox;

import javax.inject.Inject;

public class Blow extends Task {
    @Inject
    private Glassblower plugin;

    @Inject
    private Config config;

    @Override
    public String getStatus() {
        return "Glassblowing";
    }

    @Override
    public boolean validate() {
        return game.inventory().withId(ItemID.GLASSBLOWING_PIPE).exists()
                && game.inventory().withId(ItemID.MOLTEN_GLASS).exists()
                && plugin.getCurrentActivity() == Activity.IDLE;
    }

    @Override
    public void execute() {
        if (game.localPlayer().position().regionID() == Glassblower.FOSSIL_ISLAND_SMALL_ISLAND_REGION) {
            iObject rowboat = game.objects().withName("Rowboat").nearest();
            if (rowboat == null) return;

            rowboat.interact("Dive");
            game.waitUntil(() -> chatbox.chatState() == Chatbox.ChatState.OPTIONS_CHAT
                    || game.localPlayer().position().regionID() == Glassblower.FOSSIL_ISLAND_SEAWEED_REGION, 10);

            if (chatbox.chatState() == Chatbox.ChatState.OPTIONS_CHAT) {
                chatbox.chooseOption(1);
                game.waitUntil(() -> game.localPlayer().position().regionID() == Glassblower.FOSSIL_ISLAND_SEAWEED_REGION, 10);
            }
            game.tick();
        }

        if (game.groundItems().withId(ItemID.SEAWEED_SPORE).exists()) return;

        InventoryItem pipe = game.inventory().withId(ItemID.GLASSBLOWING_PIPE).first();
        InventoryItem moltenGlass = game.inventory().withId(ItemID.MOLTEN_GLASS).first();
        if (pipe == null || moltenGlass == null) return;

        pipe.useOn(moltenGlass);
        game.waitUntil(() -> chatbox.chatState() == Chatbox.ChatState.MAKE, 5);

        int quantity = (int) game.inventory().withId(ItemID.MOLTEN_GLASS).count();

        chatbox.make(config.targetProduct().getMakeIndex(), quantity);
        game.waitUntil(() -> plugin.getCurrentActivity() == Activity.GLASSBLOWING, 5);
    }
}
