package io.reisub.openosrs.glassblower.tasks;

import io.reisub.openosrs.glassblower.Glassblower;
import io.reisub.openosrs.util.Task;
import net.runelite.api.ItemID;
import net.runelite.client.plugins.iutils.game.iObject;

import java.time.Duration;
import java.time.Instant;

public class HandleBank extends Task {
    private Instant lastBanking = Instant.EPOCH;

    @Override
    public String getStatus() {
        return "Banking";
    }

    @Override
    public boolean validate() {
        return !game.inventory().withId(ItemID.MOLTEN_GLASS).exists()
                && Duration.between(lastBanking, Instant.now()).getSeconds() > 5;
    }

    @Override
    public void execute() {
        if (game.localPlayer().position().regionID() == Glassblower.FOSSIL_ISLAND_SEAWEED_REGION) {
            iObject rope = game.objects().withName("Anchor rope").first();
            if (rope == null) return;

            rope.interact("Climb");
            if (!game.waitUntil(() -> game.localPlayer().position().regionID() == Glassblower.FOSSIL_ISLAND_SMALL_ISLAND_REGION
                    || game.groundItems().withId(ItemID.SEAWEED_SPORE).exists(), 30)) {
                return;
            }

            if (game.groundItems().withId(ItemID.SEAWEED_SPORE).exists()) return;

            game.tick();
        }

        if (!bank.isOpen()) {
            iObject bankObj = game.objects().withName("Bank chest", "Bank booth", "Bank Chest-wreck").nearest();
            if (bankObj == null) return;

            bankObj.interact(0);
            game.waitUntil(() -> bank.isOpen(), 15);
        }

        bank.depositExcept(false, ItemID.GLASSBLOWING_PIPE, ItemID.SEAWEED_SPORE);
//        bank.depositAll(false, ItemID.BEER_GLASS,
//                ItemID.EMPTY_CANDLE_LANTERN,
//                ItemID.EMPTY_OIL_LAMP,
//                ItemID.VIAL,
//                ItemID.FISHBOWL,
//                ItemID.UNPOWERED_ORB,
//                ItemID.LANTERN_LENS,
//                ItemID.LIGHT_ORB);
        game.tick();
        game.sleepDelay();

        if (!game.inventory().withId(ItemID.GLASSBLOWING_PIPE).exists()) {
            bank.withdraw(ItemID.GLASSBLOWING_PIPE, 1, false);
            game.sleepDelay();
        }

        int quantity = game.inventory().withId(ItemID.SEAWEED_SPORE).exists() ? 26 : 27;

        bank.withdraw(ItemID.MOLTEN_GLASS, quantity, false);
        game.sleepDelay();

        bank.close();
        game.sleepDelay();
        lastBanking = Instant.now();
    }
}
