package io.reisub.openosrs.herblore.tasks;

import io.reisub.openosrs.herblore.Herblore;
import io.reisub.openosrs.util.Task;
import io.reisub.openosrs.util.enums.Activity;

import javax.inject.Inject;

public class Clean extends Task {
    @Inject
    private Herblore plugin;

    @Override
    public String getStatus() {
        return "Cleaning herbs";
    }

    @Override
    public boolean validate() {
        return plugin.shouldClean()
                && plugin.getCurrentActivity() == Activity.IDLE
                && game.inventory().withId(plugin.getGrimyHerbIds()).exists();
    }

    @Override
    public void execute() {
        plugin.setActivity(Activity.CLEANING_HERBS);

        game.inventory().withId(plugin.getGrimyHerbIds()).forEach((herb) -> herb.interact("Clean"));
        game.tick();
    }
}
