package io.reisub.openosrs.herblore.tasks;

import io.reisub.openosrs.herblore.Herblore;
import io.reisub.openosrs.util.Task;
import io.reisub.openosrs.util.enums.Activity;
import net.runelite.client.plugins.iutils.game.InventoryItem;
import net.runelite.client.plugins.iutils.ui.Chatbox;

import javax.inject.Inject;
import java.util.List;

public class MakePotion extends Task {
    @Inject
    private Herblore plugin;

    @Override
    public String getStatus() {
        return "Making potions";
    }

    @Override
    public boolean validate() {
        return plugin.shouldMakePotion()
                && plugin.getCurrentActivity() == Activity.IDLE
                && game.inventory().withId(plugin.getSecondaryIds()).exists()
                && game.inventory().withId(plugin.getBaseIds()).exists();
    }

    @Override
    public void execute() {
        plugin.setActivity(Activity.CREATING_POTIONS);

        List<InventoryItem> secondaries = game.inventory().withId(plugin.getSecondaryIds()).all();
        List<InventoryItem> bases = game.inventory().withId(plugin.getBaseIds()).all();

        if (secondaries.size() == 0 || bases.size() == 0) return;

        int quantity = Math.min(secondaries.size(), bases.size());

        secondaries.get(0).useOn(bases.get(0));
        game.waitUntil(() -> chatbox.chatState() == Chatbox.ChatState.MAKE, 5);

        chatbox.make(0, quantity);
        game.tick();
    }
}
