package io.reisub.openosrs.herblore.tasks;

import io.reisub.openosrs.herblore.Herblore;
import io.reisub.openosrs.util.Task;
import io.reisub.openosrs.util.enums.Activity;
import net.runelite.api.ItemID;
import net.runelite.client.plugins.iutils.game.InventoryItem;
import net.runelite.client.plugins.iutils.ui.Chatbox;

import javax.inject.Inject;
import java.util.List;

public class MakeUnfinished extends Task {
    @Inject
    private Herblore plugin;

    @Override
    public String getStatus() {
        return "Making unfinished potions";
    }

    @Override
    public boolean validate() {
        return plugin.shouldMakeUnfinished()
                && plugin.getCurrentActivity() == Activity.IDLE
                && game.inventory().withId(plugin.getCleanHerbIds()).exists()
                && game.inventory().withId(ItemID.VIAL_OF_WATER, ItemID.VIAL_OF_BLOOD, ItemID.COCONUT_MILK).exists();
    }

    @Override
    public void execute() {
        plugin.setActivity(Activity.CREATING_UNFINISHED_POTIONS);

        List<InventoryItem> herbs = game.inventory().withId(plugin.getCleanHerbIds()).all();
        List<InventoryItem> bases = game.inventory().withId(ItemID.VIAL_OF_WATER, ItemID.VIAL_OF_BLOOD, ItemID.COCONUT_MILK).all();

        if (herbs.size() == 0 || bases.size() == 0) return;

        int quantity = Math.min(herbs.size(), bases.size());

        herbs.get(0).useOn(bases.get(0));
        game.waitUntil(() -> chatbox.chatState() == Chatbox.ChatState.MAKE, 5);

        chatbox.make(0, quantity);
        game.tick();
    }
}
