package io.reisub.openosrs.masterthiever;

import com.google.inject.Provides;
import io.reisub.openosrs.masterthiever.tasks.HandleBank;
import io.reisub.openosrs.masterthiever.tasks.Steal;
import io.reisub.openosrs.util.CScript;
import io.reisub.openosrs.util.Util;
import io.reisub.openosrs.util.enums.Activity;
import io.reisub.openosrs.util.tasks.Eat;
import lombok.extern.slf4j.Slf4j;
import net.runelite.api.Actor;
import net.runelite.api.Skill;
import net.runelite.api.events.AnimationChanged;
import net.runelite.api.events.ItemContainerChanged;
import net.runelite.api.events.StatChanged;
import net.runelite.client.config.ConfigManager;
import net.runelite.client.eventbus.Subscribe;
import net.runelite.client.plugins.PluginDependency;
import net.runelite.client.plugins.PluginDescriptor;
import net.runelite.client.plugins.iutils.iUtils;
import org.pf4j.Extension;

import javax.inject.Inject;

@Extension
@PluginDependency(Util.class)
@PluginDependency(iUtils.class)
@PluginDescriptor(
	name = "Chaos Master Thiever",
	description = "Cor blimey mate, what are ye doing in me pockets?",
	enabledByDefault = false
)
@Slf4j
public class MasterThiever extends CScript {
	@Inject
	private Config config;

	private Eat eatTask;

	@Provides
	Config provideConfig(ConfigManager configManager) {
		return configManager.getConfig(Config.class);
	}

	@Override
	protected void onStart() {
		super.onStart();

		eatTask = injector.getInstance(Eat.class);
		eatTask.setInterval(config.minEatHP(), config.maxEatHP());

		tasks.add(eatTask);
		addTask(HandleBank.class);
		addTask(Steal.class);
	}

	@Subscribe
	private void onAnimationChanged(AnimationChanged event) {
		Actor actor = event.getActor();
		if (actor == null || actor.getName() == null) return;

		if (!actor.getName().equals(game.localPlayer().name())) return;

		switch (game.localPlayer().animation()) {
			case 388:
				setActivity(Activity.IDLE);
				break;
		}
	}

	@Subscribe
	private void onStatChanged(StatChanged event) {
		if (event.getSkill() == Skill.THIEVING) {
			setActivity(Activity.IDLE);
		}
	}

	public int getEatThreshold() {
		return eatTask.getThreshold();
	}
}