package io.reisub.openosrs.masterthiever.tasks;

import io.reisub.openosrs.masterthiever.Config;
import io.reisub.openosrs.masterthiever.MasterThiever;
import io.reisub.openosrs.util.Task;
import net.runelite.api.ItemID;
import net.runelite.api.Skill;
import net.runelite.client.plugins.iutils.api.Interactable;
import net.runelite.client.plugins.iutils.game.iObject;
import net.runelite.client.plugins.iutils.scene.Position;

import javax.inject.Inject;

public class HandleBank extends Task {
    @Inject
    private MasterThiever plugin;

    @Inject
    private Config config;

    @Override
    public String getStatus() {
        return "Banking";
    }

    @Override
    public boolean validate() {
        return game.client().getLocalPlayer().getModelHeight() != 1000
                && (game.inventory().full()
                || (!game.inventory().withAction("Eat").exists() && game.modifiedLevel(Skill.HITPOINTS) <= plugin.getEatThreshold()));
    }

    @Override
    public void execute() {
        game.tick();
        if (!bank.isOpen()) {
            iObject bankObj = game.objects().withAction("Bank").withPosition(new Position(3091, 3245, 0)).first();
            if (bankObj == null) {
                bankObj = game.objects().withName("Bank chest", "Bank booth", "Bank Chest-wreck").withAction("Bank").nearest();
            }

            if (bankObj == null) {
                walking.walkTo(new Position(3090, 3248, 0).areaWithin(2));
                return;
            }

            bankObj.interact("Bank");
            game.waitUntil(() -> bank.isOpen(), 15);
        }

        bank.depositInventory();
        game.tick();

        int missingHp = game.baseLevel(Skill.HITPOINTS) - game.modifiedLevel(Skill.HITPOINTS);

        int quantity = config.healAtBank() ? missingHp / config.food().getHp() : 5 + (missingHp / config.food().getHp());

        bank.withdraw(ItemID.SALMON, quantity, false);
        game.waitUntil(() -> game.inventory().withAction("Eat", "Drink").count() > 1, 6);

        bank.close();
        game.waitUntil(() -> !bank.isOpen(), 3);

        if (config.healAtBank()) {
            game.inventory().withId(config.food().getId()).forEach((food) -> {
                food.interact(0);
                game.tick(3);
            });
        }
    }
}
