/*
 * Copyright (c) 2018, Andrew EP | ElPinche256 <https://github.com/ElPinche256>
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
package io.reisub.openosrs.miner;

import io.reisub.openosrs.util.enums.Log;
import net.runelite.client.config.Button;
import net.runelite.client.config.ConfigGroup;
import net.runelite.client.config.ConfigItem;

@ConfigGroup("chaosminer")

public interface Config extends net.runelite.client.config.Config {
    @ConfigItem(
            keyName = "3t4g",
            name = "3t4g mining",
            description = "Enable three tick, four granite mining.",
            position = 0
    )
    default boolean threeTickFourGranite() { return false; }

    @ConfigItem(
            keyName = "3t4s",
            name = "3t4s mining",
            description = "Enable three tick, four sandstone mining.",
            position = 1
    )
    default boolean threeTickFourSandstone() { return false; }

    @ConfigItem(
            keyName = "prepareBirdhouseRun",
            name = "Prepare for birdhouse run",
            description = "When enabled, will teleport away when out of water and withdraw materials needed for a birdhouse run. Either do the run manually or use the Chaos Birdhouse plugin.",
            position = 10
    )
    default boolean prepareBirdhouseRun() { return false; }

    @ConfigItem(
            keyName = "birdhouseLogs",
            name = "Logs",
            description = "What log type to take out of the bank for birdhouse runs.",
            hidden = true,
            unhide = "prepareBirdhouseRun",
            position = 11
    )
    default Log birdhouseLogs() { return Log.YEW; }

    @ConfigItem(
            keyName = "startButton",
            name = "Start/Stop",
            description = "Start the script",
            position = 100
    )
    default Button startButton() {
        return new Button();
    }
}