package io.reisub.openosrs.miner.tasks;

import io.reisub.openosrs.util.Task;
import net.runelite.api.ItemID;

import java.time.Duration;
import java.time.Instant;

public class Drop extends Task {
    private Instant lastDrop = Instant.EPOCH;

    @Override
    public String getStatus() {
        return "Dropping";
    }

    @Override
    public boolean validate() {
        return Duration.between(lastDrop, Instant.now()).getSeconds() > 1
                && (game.inventory().withNamePart("Granite").exists()
                || game.inventory().withId(ItemID.WATERSKIN0).exists());
    }

    @Override
    public void execute() {
        boolean inventoryIsFull = game.inventory().full();

        game.inventory().withNamePart("Granite").drop();
        game.inventory().withId(ItemID.WATERSKIN0).drop();

        if (inventoryIsFull) {
            game.waitUntil(() -> !game.inventory().full(), 5);
        }

        lastDrop = Instant.now();
    }
}
