package io.reisub.openosrs.miner.tasks;

import io.reisub.openosrs.miner.Config;
import io.reisub.openosrs.miner.Miner;
import io.reisub.openosrs.util.Task;
import net.runelite.client.plugins.iutils.scene.Position;

import javax.inject.Inject;

public class WalkToStartPosition extends Task {
    @Inject
    private Miner plugin;

    @Inject
    private Config config;

    public static final Position sandstoneStartPosition = new Position(3165, 2914, 0);

    @Override
    public String getStatus() {
        return "Walking to starting position";
    }

    @Override
    public boolean validate() {
        return config.threeTickFourSandstone()
                && !plugin.isStartedCycle()
                && !game.localPlayer().position().equals(sandstoneStartPosition)
                && game.localPlayer().position().regionID() == 12589
                && !game.inventory().withNamePart("Sandstone").exists();
    }

    @Override
    public void execute() {
        if (game.energy() > 25) {
            walking.setRun(true);
            game.sleepDelay();
        }

        walking.walkTo(sandstoneStartPosition);
        game.waitUntil(() -> game.localPlayer().position().equals(sandstoneStartPosition));
    }
}
