package io.reisub.openosrs.mtahelper.tasks;

import io.reisub.openosrs.mtahelper.MTAHelper;
import io.reisub.openosrs.util.Task;
import net.runelite.client.plugins.iutils.api.Spells;
import net.runelite.client.plugins.iutils.game.InventoryItem;
import net.runelite.client.plugins.iutils.game.iWidget;

import javax.inject.Inject;
import java.util.Set;

public class CastEnchant extends Task {
    @Inject
    private MTAHelper plugin;

    private final String[] enchantItems = new String[]{
            "Pentamid",
            "Cube",
            "Cylinder",
            "Icosahedron",
            "Dragonstone"
    };

    private long last = 0;

    @Override
    public String getStatus() {
        return "Casting enchant spell";
    }

    @Override
    public boolean validate() {
        return plugin.isInRegion(MTAHelper.MTA_REGION)
                && game.localPlayer().position().z == 0
                && game.inventory().withName(enchantItems).exists()
                && game.ticks() > last + 3;
    }

    @Override
    public void execute() {
        InventoryItem item = game.inventory().withName(enchantItems).first();
        if (item == null) return;

        iWidget spellWidget = game.widget(Spells.LVL5_ENCHANT.getInfo());
        if (spellWidget == null) return;

        spellWidget.useOn(item);

        last = game.ticks();
    }
}
