package io.reisub.openosrs.mtahelper.tasks;

import io.reisub.openosrs.mtahelper.MTAHelper;
import io.reisub.openosrs.util.Task;
import net.runelite.api.widgets.WidgetID;
import net.runelite.client.plugins.iutils.api.Spells;
import net.runelite.client.plugins.iutils.game.InventoryItem;
import net.runelite.client.plugins.iutils.game.iWidget;
import net.runelite.client.plugins.mta.alchemy.AlchemyItem;

import javax.inject.Inject;

public class CastHighAlch extends Task {
    @Inject
    private MTAHelper plugin;

    private long last;
    private AlchemyItem best = null;

    @Override
    public String getStatus() {
        return "Casting high alchemy";
    }

    @Override
    public boolean validate() {
        best = getBest();

        return plugin.isInRegion(MTAHelper.MTA_REGION)
                && game.localPlayer().position().z == 2
                && game.ticks() >= plugin.getLastHighAlchemy() + 5
                && best != null
                && (!game.inventory().withName("Coins").exists() || (game.inventory().withName("Coins").exists() && game.inventory().withName("Coins").quantity() < 10000))
                && game.inventory().withId(best.getId()).exists();
    }

    @Override
    public void execute() {
        InventoryItem item = game.inventory().withId(best.getId()).first();
        if (item == null) return;

        iWidget spellWidget = game.widget(Spells.HIGH_LEVEL_ALCHEMY.getInfo());
        if (spellWidget == null) return;

        spellWidget.useOn(item);

        plugin.setLastHighAlchemy(game.ticks());
    }

    private AlchemyItem getBest() {
        for (int i = 0; i < 5; i++) { // 12
            iWidget textWidget = game.widget(WidgetID.MTA_ALCHEMY_GROUP_ID, 7 + i);
            if (textWidget == null) return null;

            String item = textWidget.text();
            iWidget pointsWidget = game.widget(WidgetID.MTA_ALCHEMY_GROUP_ID, 12 + i);
            int points = Integer.parseInt(pointsWidget.text());

            if (points == 30) {
                return AlchemyItem.find(item);
            }
        }

        return null;
    }
}
