package io.reisub.openosrs.mtahelper.tasks;

import io.reisub.openosrs.mtahelper.MTAHelper;
import io.reisub.openosrs.util.Task;
import net.runelite.client.plugins.iutils.api.Spells;
import net.runelite.client.plugins.iutils.game.iNPC;
import net.runelite.client.plugins.iutils.game.iWidget;

import javax.inject.Inject;

public class CastTelekineticGrab extends Task {
    @Inject
    private MTAHelper plugin;

    @Override
    public String getStatus() {
        return "Casting telekinetic grab";
    }

    @Override
    public boolean validate() {
        return plugin.isCastTelekineticGrab();
    }

    @Override
    public void execute() {
        plugin.setCastTelekineticGrab(false);

        iNPC mazeGuardian = game.npcs().withName("<col=ff9040>Maze Guardian</col>").first();
        if (mazeGuardian == null) return;

        iWidget spellWidget = game.widget(Spells.TELEKINETIC_GRAB.getInfo());
        if (spellWidget == null) return;

        spellWidget.useOn(mazeGuardian);
    }
}
