/*
 * Copyright (c) 2018, Andrew EP | ElPinche256 <https://github.com/ElPinche256>
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
package io.reisub.openosrs.prayerflick;

import net.runelite.client.config.ConfigGroup;
import net.runelite.client.config.ConfigItem;
import net.runelite.client.config.Keybind;

import java.awt.event.InputEvent;
import java.awt.event.KeyEvent;

@ConfigGroup("chaosprayerflicking")

public interface Config extends net.runelite.client.config.Config {
    @ConfigItem(
            keyName = "prayerFlickHotkey",
            name = "Flick hotkey",
            description = "When you press this key prayer flicking will start",
            position = 0
    )
    default Keybind prayerFlickHotkey() {
        return new Keybind(KeyEvent.VK_BACK_QUOTE, 0);
    }

    @ConfigItem(
            keyName = "deactivateAfterStopping",
            name = "Deactivate prayers after stopping",
            description = "Deactivate prayers after stopping prayer flicking.",
            position = 10
    )
    default boolean deactivateAfterStopping() {
        return true;
    }

    @ConfigItem(
            keyName = "hotkeyMelee",
            name = "Melee hotkey",
            description = "When you press this key protect from melee will be set as quickprayer",
            position = 20
    )
    default Keybind hotkeyMelee() {
        return new Keybind(KeyEvent.VK_1, InputEvent.CTRL_DOWN_MASK);
    }

    @ConfigItem(
            keyName = "hotkeyMissiles",
            name = "Missiles hotkey",
            description = "When you press this key protect from missiles will be set as quickprayer",
            position = 21
    )
    default Keybind hotkeyMissiles() {
        return new Keybind(KeyEvent.VK_2, InputEvent.CTRL_DOWN_MASK);
    }

    @ConfigItem(
            keyName = "hotkeyMagic",
            name = "Magic hotkey",
            description = "When you press this key protect from magic will be set as quickprayer",
            position = 22
    )
    default Keybind hotkeyMagic() {
        return new Keybind(KeyEvent.VK_3, InputEvent.CTRL_DOWN_MASK);
    }

    @ConfigItem(
            keyName = "openInventory",
            name = "Open inventory",
            description = "Open inventory after swapping quickprayers",
            position = 23
    )
    default boolean openInventory() { return true; }

    @ConfigItem(
            keyName = "allowToggleOff",
            name = "Allow toggling off",
            description = "Will allow turning the protect prayer off when pressing the hotkey for the current one.",
            position = 24
    )
    default boolean allowToggleOff() { return true; }

    @ConfigItem(
            keyName = "jadPrayerFlick",
            name = "Jad Auto Prayer Flick",
            description = "Automatically swap prayers against Jad.",
            position = 30
    )
    default boolean jadPrayerFlick() { return true; }

    @ConfigItem(
            keyName = "hesporiPrayerFlick",
            name = "Hespori Auto Prayer Flick",
            description = "Automatically swap prayers against Hespori.",
            position = 31
    )
    default boolean hesporiPrayerFlick() { return true; }

    @ConfigItem(
            keyName = "showDebugOptions",
            name = "Show debug options",
            description = "Show debug options. Probably shouldn't touch these.",
            position = 90
    )
    default boolean showDebugOptions() { return false; }

    @ConfigItem(
            keyName = "onDelayMin",
            name = "On delay minimum",
            description = "Minimum wait time for toggling on quickprayers.",
            hidden = true,
            unhide = "showDebugOptions",
            position = 91
    )
    default int onDelayMin() { return 5; }

    @ConfigItem(
            keyName = "onDelayMax",
            name = "On delay maximum",
            description = "Maximum wait time for toggling on quickprayers.",
            hidden = true,
            unhide = "showDebugOptions",
            position = 92
    )
    default int onDelayMax() { return 10; }

    @ConfigItem(
            keyName = "offDelayMin",
            name = "Off delay minimum",
            description = "Minimum wait time for toggling off quickprayers.",
            hidden = true,
            unhide = "showDebugOptions",
            position = 93
    )
    default int offDelayMin() { return 70; }

    @ConfigItem(
            keyName = "offDelayMax",
            name = "Off delay maximum",
            description = "Maximum wait time for toggling off quickprayers.",
            hidden = true,
            unhide = "showDebugOptions",
            position = 94
    )
    default int offDelayMax() { return 80; }
}