package io.reisub.openosrs.shopper.tasks;

import io.reisub.openosrs.shopper.Item;
import io.reisub.openosrs.shopper.Shopper;
import io.reisub.openosrs.util.Task;
import net.runelite.api.widgets.Widget;
import net.runelite.client.plugins.iutils.game.iWidget;

import javax.inject.Inject;

public class Buy extends Task {
    @Inject
    private Shopper plugin;

    @Override
    public String getStatus() {
        return "Buying";
    }

    private int currentItemId;

    @Override
    public boolean validate() {
        iWidget shop = game.widget(300, 1);
        if (shop == null || shop.hidden()) return false;

        currentItemId = -1;

        for (Item item : plugin.getItems()) {
            if (item.getAmountBought() > item.getAmountToBuy()) continue;

            int shopCount = getShopCount(item.getId());

            if (shopCount > item.getMinInShop()) {
                currentItemId = item.getId();
                break;
            }
        }

        return currentItemId != -1
                && !game.inventory().full();
    }

    @Override
    public void execute() {
        Widget widget = game.client().getWidget(300, 16);

        for (Widget child : widget.getChildren()) {
            if (child.getItemId() == currentItemId) {
                iWidget itemWidget = game.widget(300, 16, child.getIndex());
                if (itemWidget == null) return;

                itemWidget.interact("Buy 50");

                break;
            }
        }

        game.tick();
    }

    private int getShopCount(int id) {
        Widget widget = game.client().getWidget(300, 16);

        for (Widget child : widget.getChildren()) {
            if (child.getItemId() == id) {
                return child.getItemQuantity();
            }
        }

        return 0;
    }
}
