package io.reisub.openosrs.shopper.tasks;

import io.reisub.openosrs.shopper.Config;
import io.reisub.openosrs.util.Task;
import net.runelite.client.plugins.iutils.game.iNPC;
import net.runelite.client.plugins.iutils.game.iWidget;
import net.runelite.client.plugins.iutils.scene.Position;

import javax.inject.Inject;

public class OpenShop extends Task {
    @Inject
    private Config config;

    @Override
    public String getStatus() {
        return "Opening shop";
    }

    @Override
    public boolean validate() {
        iWidget shop = game.widget(300, 1);

        return !bank.isOpen()
                && !game.inventory().full()
                && (shop == null || shop.hidden());
    }

    @Override
    public void execute() {
        iNPC npc = game.npcs().withName(config.npcName()).nearest();
        if (npc == null) {
            walking.walkTo(new Position(2669, 3150, 0).areaWithin(2));
        }

        npc = game.npcs().withName(config.npcName()).nearest();
        if (npc == null) return;

        npc.interact("Trade");
        game.waitUntil(() -> game.widget(300, 1) != null
                && !game.widget(300, 1).hidden(), 20);
    }
}
