package io.reisub.openosrs.smelter.tasks;

import io.reisub.openosrs.smelter.Config;
import io.reisub.openosrs.smelter.Ingredient;
import io.reisub.openosrs.smelter.Smelter;
import io.reisub.openosrs.util.Task;
import io.reisub.openosrs.util.enums.Activity;
import net.runelite.client.plugins.iutils.game.iObject;
import net.runelite.client.plugins.iutils.ui.Chatbox;

import javax.inject.Inject;

public class Smelt extends Task {
    @Inject
    private Smelter plugin;

    @Inject
    private Config config;

    @Override
    public String getStatus() {
        return "Smelting";
    }

    @Override
    public boolean validate() {
        boolean hasAllIngredients = true;

        for (Ingredient ingredient : config.targetProduct().getIngredients()) {
            if (!game.inventory().withId(ingredient.getId()).exists()) {
                hasAllIngredients = false;
            }
        }

        return hasAllIngredients && plugin.getCurrentActivity() == Activity.IDLE;
    }

    @Override
    public void execute() {
        iObject furnace = game.objects().withName("Furnace").nearest();
        if (furnace == null) return;

        furnace.interact("Smelt");
        game.waitUntil(() -> chatbox.chatState() == Chatbox.ChatState.MAKE, 15);

        int quantity = 28;
        for (Ingredient ingredient : config.targetProduct().getIngredients()) {
            int count = (int) game.inventory().withId(ingredient.getId()).count();

            if (quantity > count) {
                quantity = count;
            }
        }

        chatbox.make(config.targetProduct().getIndex(), quantity);
        game.waitUntil(() -> plugin.getCurrentActivity() == Activity.SMELTING, 5);
    }
}
