package io.reisub.openosrs.smither;

import com.google.inject.Provides;

import io.reisub.openosrs.smither.tasks.HandleBank;
import io.reisub.openosrs.smither.tasks.Smith;
import io.reisub.openosrs.util.CScript;
import io.reisub.openosrs.util.Task;
import io.reisub.openosrs.util.Util;
import io.reisub.openosrs.util.enums.Activity;
import io.reisub.openosrs.util.tasks.Eat;
import io.reisub.openosrs.util.tasks.KittenTask;
import io.reisub.openosrs.util.tasks.Run;
import lombok.Getter;
import lombok.extern.slf4j.Slf4j;
import net.runelite.api.AnimationID;
import net.runelite.api.events.AnimationChanged;
import net.runelite.api.events.ChatMessage;
import net.runelite.api.events.ConfigButtonClicked;
import net.runelite.api.events.ItemContainerChanged;
import net.runelite.client.config.ConfigManager;
import net.runelite.client.eventbus.Subscribe;
import net.runelite.client.plugins.PluginDependency;
import net.runelite.client.plugins.PluginDescriptor;
import net.runelite.client.plugins.iutils.iUtils;
import net.runelite.client.plugins.iutils.scripts.iScript;
import org.pf4j.Extension;

import javax.inject.Inject;
import java.time.Duration;
import java.util.ArrayList;
import java.util.List;

@Extension
@PluginDependency(Util.class)
@PluginDependency(iUtils.class)
@PluginDescriptor(
	name = "Chaos Smither",
	description = "I shall make weapons from your bones!",
	enabledByDefault = false
)
@Slf4j
public class Smither extends CScript {
	@Inject
	private Config config;

	@Provides
	Config provideConfig(ConfigManager configManager) {
		return configManager.getConfig(Config.class);
	}

	@Override
	protected void onStart() {
		super.onStart();

		lastActionTimeout = Duration.ofSeconds(5);

		Run runTask = injector.getInstance(Run.class);
		runTask.setInterval(70, 95);
		tasks.add(runTask);

		addTask(HandleBank.class);
		addTask(Smith.class);
	}

	@SuppressWarnings("unused")
	@Subscribe
	private void onItemContainerChanged(ItemContainerChanged event) {
		int bars = (int) game.inventory().withId(config.metalType().getBarId()).count();

		if (bars < config.product().getRequiredBars() && currentActivity == Activity.SMITHING) {
			setActivity(Activity.IDLE);
		}
	}

	@SuppressWarnings("unused")
	@Subscribe
	private void onAnimationChanged(AnimationChanged event) {
		if (!isLoggedIn()) return;

		int animId = game.localPlayer().animation();
		switch (animId) {
			case AnimationID.SMITHING_ANVIL:
			case AnimationID.SMITHING_IMCANDO_HAMMER:
				setActivity(Activity.SMITHING);
				break;
		}
	}
}