package io.reisub.openosrs.smither.tasks;

import io.reisub.openosrs.smither.Config;
import io.reisub.openosrs.smither.Smither;
import io.reisub.openosrs.util.Task;
import io.reisub.openosrs.util.enums.Activity;
import net.runelite.api.AnimationID;
import net.runelite.api.widgets.WidgetInfo;
import net.runelite.client.plugins.iutils.game.iObject;
import net.runelite.client.plugins.iutils.game.iWidget;

import javax.inject.Inject;

public class Smith extends Task {
    @Inject
    private Smither plugin;

    @Inject
    private Config config;

    @Override
    public String getStatus() {
        return "Smithing";
    }

    @Override
    public boolean validate() {
        return plugin.getCurrentActivity() == Activity.IDLE
                && !bank.isOpen()
                && game.inventory().withId(config.metalType().getBarId()).count() >= config.product().getRequiredBars();
    }

    @Override
    public void execute() {
        iObject anvil = game.objects().withName("Anvil").withAction("Smith").nearest();
        if (anvil == null) return;

        anvil.interact("Smith");
        game.waitUntil(() -> game.widget(WidgetInfo.SMITHING_INVENTORY_ITEMS_CONTAINER) != null, 15);

        iWidget productWidget = game.widget(312, config.product().getInterfaceId());
        if (productWidget == null) return;

        productWidget.interact("Smith");

        game.waitUntil(() -> game.localPlayer().animation() == AnimationID.SMITHING_ANVIL
                || game.localPlayer().animation() == AnimationID.SMITHING_IMCANDO_HAMMER, 10);
        game.tick();
    }
}
