package io.reisub.openosrs.superglassmake;

import com.google.inject.Provides;
import io.reisub.openosrs.superglassmake.tasks.CastSuperglassMake;
import io.reisub.openosrs.superglassmake.tasks.HandleBank;
import io.reisub.openosrs.superglassmake.tasks.PickupGlass;
import io.reisub.openosrs.util.CScript;
import io.reisub.openosrs.util.Util;
import io.reisub.openosrs.util.tasks.Run;
import lombok.extern.slf4j.Slf4j;
import net.runelite.client.config.ConfigManager;
import net.runelite.client.plugins.PluginDependency;
import net.runelite.client.plugins.PluginDescriptor;
import net.runelite.client.plugins.iutils.iUtils;
import org.pf4j.Extension;

@Extension
@PluginDependency(Util.class)
@PluginDependency(iUtils.class)
@PluginDescriptor(
	name = "Chaos Superglass Make",
	description = "A super Superglass Make caster",
	enabledByDefault = false
)
@Slf4j
public class SuperglassMake extends CScript {
	@Provides
	Config provideConfig(ConfigManager configManager) {
		return configManager.getConfig(Config.class);
	}

	@Override
	protected void onStart() {
		super.onStart();

		Run runTask = injector.getInstance(Run.class);
		runTask.setInterval(70, 95);
		tasks.add(runTask);

		addTask(PickupGlass.class);
		addTask(CastSuperglassMake.class);
		addTask(HandleBank.class);
	}
}