package io.reisub.openosrs.superglassmake.tasks;

import io.reisub.openosrs.superglassmake.SuperglassMake;
import io.reisub.openosrs.util.Task;
import net.runelite.api.ItemID;
import net.runelite.client.plugins.iutils.game.iObject;
import net.runelite.client.plugins.iutils.scene.Position;

import javax.inject.Inject;
import java.time.Duration;
import java.time.Instant;

public class HandleBank extends Task {
    @Inject
    private SuperglassMake plugin;

    private Instant last = Instant.EPOCH;

    @Override
    public String getStatus() {
        return "Banking";
    }

    @Override
    public boolean validate() {
        return !game.inventory().withId(ItemID.BUCKET_OF_SAND).exists();
    }

    @Override
    public void execute() {
        if (!bank.isOpen()) {
            iObject bankObj = game.objects().withName("Bank chest", "Bank booth", "Bank Chest-wreck", "Bank chest").withPosition(new Position(2098, 3920, 0)).nearest();
            if (bankObj == null) return;

            if (bankObj.actions().contains("Bank")) {
                bankObj.interact("Bank");
            } else if (bankObj.actions().contains("Use")) {
                bankObj.interact("Use");
            } else {
                bankObj.interact(0);
            }

            game.waitUntil(() -> bank.isOpen(), 3);
        }

        bank.depositExcept(false, ItemID.ASTRAL_RUNE);
        game.sleepDelay();

        if (bank.quantity(ItemID.BUCKET_OF_SAND) == 0 || (bank.quantity(ItemID.SODA_ASH) == 0 && bank.quantity(ItemID.GIANT_SEAWEED) == 0)) {
            plugin.stop("Out of materials, stopping plugin");
        }

        if (bank.contains(ItemID.SODA_ASH)) {
            bank.withdraw(ItemID.BUCKET_OF_SAND, 13, false);
            game.sleepDelay();

            bank.withdraw(ItemID.SODA_ASH, 13, false);
            game.sleepDelay();
        } else {
            bank.withdraw(ItemID.BUCKET_OF_SAND, 18, false);
            game.sleepDelay();

            for (int i = 0; i < 3; i++) {
                bank.withdraw(ItemID.GIANT_SEAWEED, 1, false);
                game.sleepDelay();
            }
        }

        bank.close();
        game.waitUntil(() -> game.inventory().withId(ItemID.BUCKET_OF_SAND).exists(), 5);
        last = Instant.now();
    }
}
