package io.reisub.openosrs.superglassmake.tasks;

import io.reisub.openosrs.superglassmake.Config;
import io.reisub.openosrs.util.Task;
import net.runelite.api.ItemID;
import net.runelite.client.plugins.iutils.game.iGroundItem;

import javax.inject.Inject;
import java.time.Duration;
import java.time.Instant;

public class PickupGlass extends Task {
    @Inject
    private Config config;

    private Instant last = Instant.EPOCH;

    @Override
    public String getStatus() {
        return "Picking up glass";
    }

    @Override
    public boolean validate() {
        return config.pickupGlass()
                && Duration.between(last, Instant.now()).getSeconds() > 5
                && game.groundItems().withId(ItemID.MOLTEN_GLASS).withPosition(game.localPlayer().position()).exists();
    }

    @Override
    public void execute() {
        for (iGroundItem glass : game.groundItems().withId(ItemID.MOLTEN_GLASS).withPosition(game.localPlayer().position()).all()) {
            glass.interact(0);
            game.sleepDelay();
        }

        last = Instant.now();
    }
}
