package io.reisub.openosrs.tempoross.tasks;

import io.reisub.openosrs.tempoross.Activity;
import io.reisub.openosrs.tempoross.Tempoross;
import io.reisub.openosrs.util.Task;

import javax.inject.Inject;

public class Attack extends Task {
    @Inject
    private Tempoross plugin;

    @Override
    public String getStatus() {
        return "Attacking";
    }

    @Override
    public boolean validate() {
        if (!plugin.isInTemperossArea()) return false;

        return plugin.getCurrentActivity() == Activity.IDLE
                && game.npcs().withId().exists();
    }

    @Override
    public void execute() {
        game.npcs().withId().findFirst().ifPresent((pool) -> {
            pool.interact(0);
            game.waitUntil(() -> plugin.getCurrentActivity() == Activity.ATTACKING, 20);
        });
    }
}
