package io.reisub.openosrs.tempoross.tasks;

import io.reisub.openosrs.tempoross.Activity;
import io.reisub.openosrs.tempoross.Tempoross;
import io.reisub.openosrs.util.Task;
import net.runelite.api.ItemID;
import net.runelite.client.plugins.iutils.game.iObject;

import javax.inject.Inject;

public class Cook extends Task {
    @Inject
    private Tempoross plugin;

    @Override
    public String getStatus() {
        return "Cooking";
    }

    @Override
    public boolean validate() {
        if (!plugin.isInTemperossArea()) return false;

        if (!game.inventory().withId(ItemID.RAW_HARPOONFISH).exists()) return false;

        if (plugin.getCurrentActivity() == Activity.IDLE) {
            return true;
        }

        return false;
    }

    @Override
    public void execute() {
        iObject shrine = game.objects().withName("Shrine").nearest();
        if (shrine == null) return;

        shrine.interact("Cook-at");
        game.tick();
    }
}
