package io.reisub.openosrs.tempoross.tasks;

import io.reisub.openosrs.tempoross.Tempoross;
import io.reisub.openosrs.util.Task;

import javax.inject.Inject;

public class EnterBoat extends Task {
    @Inject
    private Tempoross plugin;

    @Override
    public String getStatus() {
        return "Entering boat";
    }

    @Override
    public boolean validate() {
        return plugin.isInDesert()
                && plugin.getPlayersReady() == 0;
    }

    @Override
    public void execute() {
        game.objects().withName("Rope ladder").findFirst().ifPresent((ladder) -> {
            ladder.interact("Climb");
            game.waitUntil(() -> plugin.isOnBoat(), 15);
        });
    }
}
