package io.reisub.openosrs.tempoross.tasks;

import io.reisub.openosrs.tempoross.Activity;
import io.reisub.openosrs.tempoross.Tempoross;
import io.reisub.openosrs.util.Task;
import net.runelite.api.ItemID;

import javax.inject.Inject;

public class FillBuckets extends Task {
    @Inject
    private Tempoross plugin;

    @Override
    public String getStatus() {
        return "Filling buckets";
    }

    @Override
    public boolean validate() {
        if (!game.inventory().withId(ItemID.BUCKET).exists()) return false;

        long filledBuckets = game.inventory().withId(ItemID.BUCKET_OF_WATER).count();
        // TODO limit to play area
        long fires = game.objects().withName("Fire").withAction("Douse").count();

        return plugin.isOnBoat() || (plugin.isInTemperossArea() && filledBuckets < fires);
    }

    @Override
    public void execute() {
        game.objects().withName("Water pump").findFirst().ifPresent((pump) -> {
            pump.interact("Use");
            game.waitUntil(() -> plugin.getCurrentActivity() == Activity.FILLING_BUCKETS, 20);
        });
    }
}
