package io.reisub.openosrs.tempoross.tasks;

import io.reisub.openosrs.tempoross.Tempoross;
import io.reisub.openosrs.util.Task;

import javax.inject.Inject;

public class LeaveBoat extends Task {
    @Inject
    private Tempoross plugin;

    @Override
    public String getStatus() {
        return "Leaving boat";
    }

    @Override
    public boolean validate() {
        return plugin.isOnBoat()
                && plugin.getPlayersReady() > 1;
    }

    @Override
    public void execute() {
        game.objects().withName("Rope ladder").findFirst().ifPresent((ladder) -> {
            ladder.interact("Climb");
            game.waitUntil(() -> plugin.isInDesert(), 15);
        });
    }
}
