package io.reisub.openosrs.tempoross.tasks;

import io.reisub.openosrs.tempoross.Activity;
import io.reisub.openosrs.tempoross.Tempoross;
import io.reisub.openosrs.util.Task;
import net.runelite.api.NullObjectID;
import net.runelite.api.ObjectID;
import net.runelite.client.plugins.iutils.game.iObject;
import net.runelite.client.plugins.iutils.scene.Position;

import javax.inject.Inject;

public class Repair extends Task {
    @Inject
    private Tempoross plugin;

    @Override
    public String getStatus() {
        return "Repairing";
    }

    @Override
    public boolean validate() {
        if (!plugin.isInTemperossArea() || !plugin.isWaveIncoming()) return false;

        iObject tetherPole = game.objects().withId(NullObjectID.NULL_41352, NullObjectID.NULL_41353, NullObjectID.NULL_41354, NullObjectID.NULL_41355).nearest();
        iObject brokenPole = game.objects().withId(ObjectID.DAMAGED_MAST_40996, ObjectID.DAMAGED_MAST_40997, ObjectID.DAMAGED_TOTEM_POLE, ObjectID.DAMAGED_TOTEM_POLE_41011).nearest();
        Position playerPos = game.localPlayer().position();

        return playerPos.distanceTo(tetherPole.position()) > playerPos.distanceTo(brokenPole.position());
    }

    @Override
    public void execute() {
        iObject brokenPole = game.objects().withId(ObjectID.DAMAGED_MAST_40996, ObjectID.DAMAGED_MAST_40997, ObjectID.DAMAGED_TOTEM_POLE, ObjectID.DAMAGED_TOTEM_POLE_41011).nearest();
        if (brokenPole == null) return;

        brokenPole.interact(0);
        game.waitUntil(() -> plugin.getCurrentActivity() == Activity.REPAIRING_MAST, 20);
    }
}
