package io.reisub.openosrs.tempoross.tasks;

import io.reisub.openosrs.tempoross.Tempoross;
import io.reisub.openosrs.util.Task;
import net.runelite.api.ItemID;

import javax.inject.Inject;

public class Stock extends Task {
    @Inject
    private Tempoross plugin;

    private int stocked;

    @Override
    public String getStatus() {
        return "Stocking cannon";
    }

    @Override
    public boolean validate() {
        if (!plugin.isInTemperossArea()) return false;

        long rawFish = game.inventory().withId(ItemID.RAW_HARPOONFISH).count();
        long cookedFish = game.inventory().withId(ItemID.HARPOONFISH).count();

        @SuppressWarnings("unused")
        long crystalFish = game.inventory().withId(ItemID.CRYSTALLISED_HARPOONFISH).count();

        // stock cannon for the first time
        // bring energy to 4%
        if (plugin.getPhase() == 1 && cookedFish == 17 && plugin.getEnergy() == 100) return true;

        // stock cannon for the second time
        // trigger first phase change
        // bring energy to 4% or as close as possible
        if (plugin.getPhase() == 1 && plugin.getEnergy() < 100
                && (plugin.getStormIntensity() >= 93 || cookedFish == 19)) return true;

        // stock cannon at phase 2
        // bring energy to 4%
        if (plugin.getPhase() == 2
                && plugin.getEnergy() != 4
                && cookedFish >= 19 - stocked) return true;

        // stock cannon at phase 2
        // trigger second phase change
        // bring energy to 4%
        if (plugin.getPhase() == 2
                && (plugin.getStormIntensity() >= 93 || cookedFish == 19)) return true;

        // stock cannon at phase 3
        // trigger third phase change and potentially fourth phase change
        if (plugin.getPhase() == 3
                && (plugin.getStormIntensity() >= 93 || (cookedFish > 0 && rawFish == 0 && game.inventory().full()))) return true;

        return false;
    }

    @Override
    public void execute() {

    }
}
