package io.reisub.openosrs.util;

import net.runelite.api.GameState;
import net.runelite.api.widgets.WidgetInfo;
import net.runelite.client.game.WorldService;
import net.runelite.client.plugins.iutils.game.Game;
import net.runelite.client.util.WorldUtil;
import net.runelite.http.api.worlds.World;
import net.runelite.http.api.worlds.WorldResult;

import javax.inject.Inject;
import java.time.Duration;
import java.time.Instant;

public class HopHelper {
    @Inject
    private Game game;

    @Inject
    private WorldService worldService;

    private Instant lastAttempt;
    private net.runelite.api.World quickHopTargetWorld;
    private int displaySwitcherAttempts = 0;

    public void prepare(int worldId) {
        if (Duration.between(lastAttempt, Instant.now()).getSeconds() < 5) return;

        WorldResult worldResult = worldService.getWorlds();
        if (worldResult == null) return;

        World world = worldResult.findWorld(worldId);
        if (world == null) return;

        final net.runelite.api.World rsWorld = game.client().createWorld();
        rsWorld.setActivity(world.getActivity());
        rsWorld.setAddress(world.getAddress());
        rsWorld.setId(world.getId());
        rsWorld.setPlayerCount(world.getPlayers());
        rsWorld.setLocation(world.getLocation());
        rsWorld.setTypes(WorldUtil.toWorldTypes(world.getTypes()));

        if (game.client().getGameState() == GameState.LOGIN_SCREEN) {
            game.client().changeWorld(rsWorld);
            return;
        }

        quickHopTargetWorld = rsWorld;
        displaySwitcherAttempts = 0;
        lastAttempt = Instant.now();
    }

    public void onGameTick() {
        if (quickHopTargetWorld == null) return;

        if (game.client().getWidget(WidgetInfo.WORLD_SWITCHER_LIST) == null) {
            game.client().openWorldHopper();
            if (++displaySwitcherAttempts >= 5) {
                displaySwitcherAttempts = 0;
                quickHopTargetWorld = null;
            }
        } else {
            game.client().hopToWorld(quickHopTargetWorld);
            quickHopTargetWorld = null;
        }
    }
}
