package io.reisub.openosrs.util;

import com.google.inject.Injector;
import lombok.extern.slf4j.Slf4j;
import net.runelite.client.plugins.iutils.api.Combat;
import net.runelite.client.plugins.iutils.api.Prayers;
import net.runelite.client.plugins.iutils.game.Game;
import net.runelite.client.plugins.iutils.ui.Bank;
import net.runelite.client.plugins.iutils.ui.Chatbox;
import net.runelite.client.plugins.iutils.ui.Equipment;
import net.runelite.client.plugins.iutils.walking.Walking;

import javax.inject.Inject;

@Slf4j
public abstract class Task {
    @Inject
    protected Game game;

    @Inject
    protected Injector injector;

    @Inject
    protected Calculations calc;

    @Inject
    protected Walking walking;

    @Inject
    protected Equipment equipment;

    @Inject
    protected Combat combat;

    @Inject
    protected Prayers prayers;

    @Inject
    protected Bank bank;

    @Inject
    protected Chatbox chatbox;

    protected void log(String msg) {
        log.info(msg);
    }

    protected void logTrace(String msg) {
        log.trace(msg);
    }

    protected void logDebug(String msg) {
        log.debug(msg);
    }

    protected void logWarn(String msg) {
        log.warn(msg);
    }

    protected void logError(String msg) {
        log.error(msg);
    }

    public abstract String getStatus();

    public abstract boolean validate();

    public abstract void execute();
}
