package io.reisub.openosrs.util;

import com.google.inject.Provides;
import lombok.extern.slf4j.Slf4j;
import net.runelite.client.config.ConfigManager;
import net.runelite.client.plugins.Plugin;
import net.runelite.client.plugins.PluginDependency;
import net.runelite.client.plugins.PluginDescriptor;
import net.runelite.client.plugins.iutils.iUtils;
import org.pf4j.Extension;

import javax.inject.Singleton;

@Extension
@PluginDependency(iUtils.class)
@PluginDescriptor(
	name = "Chaos Util",
	description = "Utilities for Chaos scripts"
)
@Slf4j
@Singleton
public class Util extends Plugin {
	@Provides
    Config provideConfig(ConfigManager configManager)
	{
		return configManager.getConfig(Config.class);
	}

	@Override
	protected void startUp()  {
		log.info(this.getName() + " started");
	}

	@Override
	protected void shutDown() {
		log.info(this.getName() + " stopped");
	}
}