package io.reisub.openosrs.util.tasks;

import io.reisub.openosrs.util.Task;

public class CutFoodForKitten extends Task {
    @Override
    public String getStatus() {
        return "Cutting food for kitten";
    }

    @Override
    public boolean validate() {
        return KittenTask.handleKitten
                && !game.inventory().withName("Roe", "Raw karambwanji").exists()
                && game.inventory().withNamePart("Leaping").exists()
                && game.inventory().withName("Knife").exists();
    }

    @Override
    public void execute() {
        if (game.inventory().full()) {
            game.inventory().withNamePart("Leaping").first().interact("Drop");
            game.tick();
        }

        long count = game.inventory().withNamePart("Leaping").count();

        game.inventory().withName("Knife").first().useOn(game.inventory().withNamePart("Leaping").first());
        game.tick();

        game.waitUntil(() -> game.inventory().withNamePart("Leaping").count() < count, 5);
    }
}
