package io.reisub.openosrs.util.tasks;

import io.reisub.openosrs.util.Task;
import net.runelite.client.plugins.iutils.game.InventoryItem;
import net.runelite.client.plugins.iutils.game.iNPC;
import net.runelite.client.plugins.iutils.ui.Chatbox;

import java.time.Duration;
import java.time.Instant;

public class HandleKitten extends Task {
    private iNPC kitten;

    private Instant lastAte;
    private Instant lastStroke;
    private int strokesDone;

    @Override
    public String getStatus() {
        return "Feeding kitten";
    }

    @Override
    public boolean validate() {
        kitten = game.npcs().filter((npc) -> npc != null
                && npc.name() != null && npc.name().equals("Kitten")
                && npc.target() != null && npc.target().name() != null && npc.target().name().equals(game.localPlayer().name())
                && npc.actions() != null && npc.actions().contains("Pick-up")).nearest();

        return KittenTask.handleKitten
                && kitten != null
                && game.inventory().withName("Roe", "Raw karambwanji").exists()
                && kitten.position().reachable(game.localPlayer().position());
    }

    @Override
    public void execute() {
        int count = getCount();

        if (lastAte == null || Duration.between(lastAte, Instant.now()).getSeconds() > 60) {
            game.inventory().withName("Roe", "Raw karambwanji").first().useOn(kitten);
            game.tick();
            if (!game.waitUntil(() -> getCount() < count && game.localPlayer().isIdle(), 10)) {
                logWarn("Timed out trying to feed our kitten");
                return;
            }

            lastAte = Instant.now();
        }

        if (lastStroke == null || Duration.between(lastStroke, Instant.now()).getSeconds() > 60) {
            int strokesToDo = strokesDone == 0 ? 2 : 1;

            for (int i = 0; i < strokesToDo; i++) {
                kitten.interact("Interact");
                game.tick();
                if (!game.waitUntil(() -> chatbox.chatState().equals(Chatbox.ChatState.OPTIONS_CHAT), 10)) {
                    logWarn("Timed out trying to stroke our kitten");
                    return;
                }

                chatbox.chooseOption("Stroke");
                game.tick();
                if (!game.waitUntil(() -> chatbox.chatState().equals(Chatbox.ChatState.PLAYER_CHAT), 10)) {
                    logWarn("Timed out trying to stroke our kitten");
                    return;
                }

                strokesDone++;
            }

            if (strokesDone == 2) {
                strokesDone = 0;
                lastStroke = Instant.now();
            }
        }

        KittenTask.handleKitten = false;
        log("Finished taking care of our kitten");
    }

    private int getCount() {
        long count = game.inventory().withName("Roe").count();

        InventoryItem karambwanji = game.inventory().withName("Raw karambwanji").first();
        if (karambwanji != null) {
            count =+karambwanji.quantity();
        }

        return (int) count;
    }
}
