package io.reisub.openosrs.util.tasks;

import io.reisub.openosrs.util.Task;
import net.runelite.client.plugins.iutils.walking.Walking;

import javax.inject.Inject;

public class Run extends Task {
    @Inject
    private Walking walking;

    private int threshold = 90;
    private int mean = 85;
    private int sigma = 5;

    public void setInterval(int min, int max) {
        mean = (min + max) / 2;
        sigma = mean - min;

        if (sigma <= 0) threshold = min;

        threshold = getNewThreshold();
    }

    @Override
    public String getStatus() {
        return "Enabling run";
    }

    @Override
    public boolean validate() {
        return !walking.isRunning() && game.energy() > threshold;
    }

    @Override
    public void execute() {
        walking.setRun(true);
        game.tick();

        threshold = getNewThreshold();
    }

    private int getNewThreshold() {
        if (sigma <= 0) {
            return threshold;
        }

        return calc.randomGauss(1, 99, sigma, mean, false);
    }
}
