package io.reisub.openosrs.wintertodt.tasks;

import io.reisub.openosrs.util.Task;
import io.reisub.openosrs.util.enums.Activity;
import io.reisub.openosrs.wintertodt.Side;
import io.reisub.openosrs.wintertodt.Wintertodt;
import net.runelite.client.plugins.iutils.scene.Position;

import javax.inject.Inject;

import static net.runelite.api.ItemID.BRUMA_KINDLING;
import static net.runelite.api.ItemID.BRUMA_ROOT;

public class Burn extends Task {
    @Inject
    public Wintertodt plugin;

    @Override
    public boolean validate() {
        if (!plugin.bossIsUp()) return false;

        if (plugin.getPreviousActivity() == Activity.WOODCUTTING && !game.inventory().full() && !plugin.shouldStartFeeding()) return false;

        return plugin.getCurrentActivity() == Activity.IDLE
                && game.inventory().withId(BRUMA_ROOT, BRUMA_KINDLING).exists();
    }

    @Override
    public void execute() {
        if (plugin.getNearestSide() == Side.WEST
                && !game.localPlayer().position().equals(new Position(1622, 3996, 0))) {
            walking.walkTo(new Position(1622, 3996, 0));
            game.tick();
            game.sleepDelay();
        }

        game.objects().withName("Burning brazier").within(15).findFirst().ifPresent((brazier) -> {
            brazier.interact("Feed");

            game.waitUntil(() -> plugin.getCurrentActivity() == Activity.FEEDING_BRAZIER || !game.objects().withName("Burning brazier").within(10).exists(), 10);
            game.tick();
        });
    }

    @Override
    public String getStatus() {
        return "Feeding brazier";
    }
}
