package io.reisub.openosrs.wintertodt.tasks;

import io.reisub.openosrs.util.Task;
import io.reisub.openosrs.util.enums.Activity;
import io.reisub.openosrs.wintertodt.Config;
import io.reisub.openosrs.wintertodt.Wintertodt;

import javax.inject.Inject;
import java.time.Duration;
import java.time.Instant;

import static net.runelite.api.NpcID.INCAPACITATED_PYROMANCER;

public class ChangeSide extends Task {
    @Inject
    public Wintertodt plugin;

    @Inject
    public Config config;

    private Instant lastIncap;

    @Override
    public String getStatus() {
        return "Changing side";
    }

    @Override
    public boolean validate() {
        if (!plugin.bossIsUp()) {
            lastIncap = null;
            return false;
        }

        if (game.npcs().within(6).withId(INCAPACITATED_PYROMANCER).exists()
                && !game.objects().withName("Burning brazier").within(15).exists()) {
            if (lastIncap == null) {
                lastIncap = Instant.now();
            }
        } else {
            lastIncap = null;
            return false;
        }

        return lastIncap != null
                && Duration.between(lastIncap, Instant.now()).getSeconds() > config.sideTimeout()
                && plugin.getCurrentActivity() == Activity.IDLE;
    }

    @Override
    public void execute() {
        lastIncap = null;

        walking.walkTo(plugin.getFurthestSide().getPositionNearBrazier());
        game.tick();
    }
}
