package io.reisub.openosrs.wintertodt.tasks;

import io.reisub.openosrs.util.Task;
import io.reisub.openosrs.util.enums.Activity;
import io.reisub.openosrs.wintertodt.Wintertodt;
import net.runelite.client.plugins.iutils.scene.Position;

import javax.inject.Inject;

public class Chop extends Task {
    @Inject
    public Wintertodt plugin;

    @Override
    public boolean validate() {
        if (!plugin.bossIsUp()) return false;

        return plugin.getCurrentActivity() == Activity.IDLE
                && !plugin.shouldStartFeeding()
                && !plugin.shouldStartFletching()
                && plugin.getBossHealth() > 4
                && !game.inventory().full();
    }

    @Override
    public void execute() {
        Position nearRoots = plugin.getNearestSide().getPositionNearRoots();
        Position nearRoots2 =  new Position(nearRoots.x, nearRoots.y+1, nearRoots.z);

        if (!game.localPlayer().position().equals(nearRoots) && !game.localPlayer().position().equals(nearRoots2)) {
            if (calc.random(0, 10) == 5) {
                walking.walkTo(nearRoots2);
            } else {
                walking.walkTo(nearRoots);
            }
            game.tick();
            game.sleepDelay();
        }

        game.objects().withName("Bruma roots").nearestFirst().findFirst().ifPresent(roots -> {
            roots.interact("Chop");
        });

        game.waitUntil(() -> plugin.getCurrentActivity() == Activity.WOODCUTTING, 20);
        game.tick();
    }

    @Override
    public String getStatus() {
        return "Chopping bruma roots";
    }
}
