package io.reisub.openosrs.wintertodt.tasks;

import io.reisub.openosrs.util.Task;
import io.reisub.openosrs.wintertodt.Wintertodt;
import io.reisub.openosrs.wintertodt.WintertodtProjectile;
import net.runelite.client.plugins.iutils.scene.Position;

import javax.inject.Inject;
import java.time.Instant;
import java.util.Iterator;

public class DodgeProjectile extends Task {
    @Inject
    public Wintertodt plugin;

    private WintertodtProjectile projectile;

    @Override
    public String getStatus() {
        return "Dodging projectile";
    }

    @Override
    public boolean validate() {
        if (plugin.getProjectiles().isEmpty()) return false;

        Instant now = Instant.now();
        for (Iterator<WintertodtProjectile> it = plugin.getProjectiles().listIterator(); it.hasNext();) {
            WintertodtProjectile p = it.next();

            if (now.isAfter(p.getStart().plusSeconds(4))) {
                it.remove();
                continue;
            }

            if (p.getDamageArea().contains(game.localPlayer().position())) {
                projectile = p;
                return true;
            }
        }

        return false;
    }

    @Override
    public void execute() {
        Position safePosition = findSafePosition(game.localPlayer().position());

        if (safePosition != null) {
            walking.walkTo(safePosition);
            game.tick();
        }

        game.waitUntil(() -> Instant.now().isAfter(projectile.getStart().plusSeconds(4)));
        game.sleepDelay();
    }

    private Position findSafePosition(Position startPosition) {
        Position safePosition = startPosition;

        while (projectile.getDamageArea().contains(safePosition)) {
            safePosition = safePosition.south();
        }
        if (walking.reachable(safePosition)) return safePosition;

        safePosition = startPosition;

        while (projectile.getDamageArea().contains(safePosition)) {
            safePosition = safePosition.north();
        }
        if (walking.reachable(safePosition)) return safePosition;

        safePosition = startPosition;

        while (projectile.getDamageArea().contains(safePosition)) {
            safePosition = safePosition.west();
        }
        if (walking.reachable(safePosition)) return safePosition;

        safePosition = startPosition;

        while (projectile.getDamageArea().contains(safePosition)) {
            safePosition = safePosition.east();
        }
        if (walking.reachable(safePosition)) return safePosition;

        return null;
    }
}
