package io.reisub.openosrs.wintertodt.tasks;

import com.google.inject.Inject;
import io.reisub.openosrs.util.Task;
import io.reisub.openosrs.wintertodt.Wintertodt;
import net.runelite.api.Skill;

import static net.runelite.api.ItemID.BRUMA_KINDLING;
import static net.runelite.api.ItemID.BRUMA_ROOT;

public class EatWhileWaiting extends Task {
    @Inject
    public Wintertodt plugin;

    @Override
    public String getStatus() {
        return "Eating";
    }

    @Override
    public boolean validate() {
        int missingHP = game.baseLevel(Skill.HITPOINTS) - game.modifiedLevel(Skill.HITPOINTS);

        return plugin.isInWintertodtRegion()
                && (plugin.getRespawnTimer() > 0 || plugin.getBossHealth() <= 4 && !game.inventory().withId(BRUMA_ROOT, BRUMA_KINDLING).exists())
                && game.inventory().withAction("Eat", "Drink").exists()
                && missingHP > calc.random(9, 12);
    }

    @Override
    public void execute() {
        game.inventory().withAction("Eat", "Drink").findFirst().ifPresent(inventoryItem -> {
            if (inventoryItem.actions().contains("Eat")) {
                inventoryItem.interact("Eat");
            } else {
                inventoryItem.interact("Drink");
            }
            game.tick(calc.random(3, 5));
        });
    }
}
