package io.reisub.openosrs.wintertodt.tasks;

import io.reisub.openosrs.util.Task;
import io.reisub.openosrs.util.enums.Activity;
import io.reisub.openosrs.wintertodt.Wintertodt;

import javax.inject.Inject;

public class Fix extends Task {
    @Inject
    public Wintertodt plugin;

    @Override
    public String getStatus() {
        return "Fixing brazier";
    }

    @Override
    public boolean validate() {
        if (!plugin.bossIsUp()) return false;

        int distance = plugin.getCurrentActivity() == Activity.IDLE ? 8 : 2;

        return game.objects().within(distance).withAction("Fix").exists()
                && plugin.getCurrentActivity() != Activity.FIXING_BRAZIER;
    }

    @Override
    public void execute() {
        int distance = plugin.getCurrentActivity() == Activity.IDLE ? 8 : 2;

        game.objects().within(distance).withAction("Fix").findFirst().ifPresent((brazier) -> {
            brazier.interact("Fix");
            game.tick();
        });

        if (distance == 2) {
            game.waitUntil(() -> plugin.getCurrentActivity() == Activity.FIXING_BRAZIER || !game.objects().within(distance).withAction("Fix").exists(), 3);
        } else {
            game.waitUntil(() -> plugin.getCurrentActivity() == Activity.FIXING_BRAZIER || !game.objects().within(distance).withAction("Fix").exists(), 6);
        }
    }
}
