package io.reisub.openosrs.wintertodt.tasks;

import io.reisub.openosrs.util.Task;
import io.reisub.openosrs.util.enums.Activity;
import io.reisub.openosrs.wintertodt.Config;
import io.reisub.openosrs.wintertodt.Wintertodt;
import net.runelite.client.plugins.iutils.scene.Position;

import javax.inject.Inject;

import static net.runelite.api.ItemID.BRUMA_ROOT;
import static net.runelite.api.ItemID.KNIFE;

public class Fletch extends Task {
    @Inject
    public Wintertodt plugin;

    @Inject
    public Config config;

    @Override
    public boolean validate() {
        if (!plugin.bossIsUp()) return false;

        if (plugin.getPreviousActivity() == Activity.WOODCUTTING && !game.inventory().full() && !plugin.shouldStartFletching()) return false;

        return plugin.getCurrentActivity() == Activity.IDLE
                && !plugin.shouldStartFeeding()
                && game.inventory().withId(BRUMA_ROOT).exists();

    }

    @Override
    public void execute() {
        if (config.fletchNearBrazier()) {
            Position nearBrazier = plugin.getNearestSide().getPositionNearBrazier();
            if (!game.localPlayer().position().equals(nearBrazier) && !game.localPlayer().position().equals(nearBrazier.south())) {
                walking.walkTo(nearBrazier);
            }
        }

        game.tick();
        game.inventory().withId(KNIFE).findFirst().ifPresent((knife) -> {
            game.inventory().withId(BRUMA_ROOT).findFirst().ifPresent(knife::useOn);
        });

        game.waitUntil(() -> plugin.getCurrentActivity() == Activity.FLETCHING, 5);
        game.tick();
    }

    @Override
    public String getStatus() {
        return "Cutting roots into kindlings";
    }
}
