package io.reisub.openosrs.wintertodt.tasks;

import io.reisub.openosrs.util.Task;
import io.reisub.openosrs.wintertodt.Wintertodt;
import net.runelite.api.Skill;
import net.runelite.client.plugins.iutils.game.iObject;
import net.runelite.client.plugins.iutils.scene.Position;

import javax.inject.Inject;

import static net.runelite.api.ItemID.BRUMA_KINDLING;
import static net.runelite.api.ItemID.BRUMA_ROOT;
import static net.runelite.api.ObjectID.DOORS_OF_DINH;

public class GoToBank extends Task {
    @Inject
    public Wintertodt plugin;

    @Override
    public boolean validate() {
        if (!plugin.isInWintertodtRegion()) return false;

        if (game.inventory().withAction("Eat", "Drink").findAny().isEmpty() && game.modifiedLevel(Skill.HITPOINTS) <= 10) return true;

        return game.inventory().withAction("Eat", "Drink").count() <= 1
                && (plugin.getRespawnTimer() > 0 || (plugin.getBossHealth() <= 4 && !game.inventory().withId(BRUMA_ROOT, BRUMA_KINDLING).exists()));
    }

    @Override
    public void execute() {
        iObject doorsOfDinh = game.objects().withId(DOORS_OF_DINH).first();
        if (doorsOfDinh == null) return;

        Position target = new Position(1630, 3970, 0);

        if (game.localPlayer().position().y > doorsOfDinh.position().y && game.localPlayer().position().distanceTo(doorsOfDinh.position()) > 8) {
            walking.walkTo(target.areaWithin(calc.random(1, 9)));
            game.tick();
        }

        game.waitUntil(() -> !plugin.bossIsUp(), 200);

        doorsOfDinh.interact("Enter");
        game.tick();
        game.waitUntil(() -> game.localPlayer().position().y < 3965, 20);

        final Position bank = new Position(1639, 3944, 0);
        walking.walkTo(bank.areaWithin(calc.random(1, 4)));
        game.tick();
    }

    @Override
    public String getStatus() {
        return "Going to the bank";
    }
}
