package io.reisub.openosrs.wintertodt.tasks;

import io.reisub.openosrs.util.Task;
import io.reisub.openosrs.wintertodt.Config;
import io.reisub.openosrs.wintertodt.Side;
import io.reisub.openosrs.wintertodt.Wintertodt;
import net.runelite.client.plugins.iutils.game.iObject;
import net.runelite.client.plugins.iutils.scene.Area;
import net.runelite.client.plugins.iutils.scene.Position;

import javax.inject.Inject;

import static net.runelite.api.ObjectID.DOORS_OF_DINH;

public class GoToWintertodt extends Task {
    @Inject
    public Wintertodt plugin;

    @Inject
    public Config config;

    @Override
    public boolean validate() {
        return !plugin.isInWintertodtRegion()
                && game.inventory().withAction("Eat", "Drink").count() > 1;
    }

    @Override
    public void execute() {
        iObject doorsOfDinh = game.objects().withId(DOORS_OF_DINH).first();
        if (doorsOfDinh == null) return;

        Position target = new Position(1630, 3962, 0);

        if (game.localPlayer().position().y < doorsOfDinh.position().y && game.localPlayer().position().distanceTo(doorsOfDinh.position()) > 7) {
            walking.walkTo(target.areaWithin(calc.random(1, 9)));
            game.tick();
        }

        doorsOfDinh.interact("Enter");
        game.tick();
        game.waitUntil(() -> game.localPlayer().position().y > 3965, 20);

        Side side = config.sideSelection();

        if (plugin.getBossHealth() > 0) {
            iObject roots = game.objects().withName("Bruma roots").nearest(game.localPlayer().position());
            roots.interact("Chop");
        } else {
            final Area wintertodtSpot = plugin.getRespawnTimer() >= 5 ? side.getPositionNearBrazier() : side.getPositionNearRoots().areaWithin(1);
            walking.walkTo(wintertodtSpot);
        }
        game.tick();
    }

    @Override
    public String getStatus() {
        return "Going to Wintertodt area";
    }
}
