package io.reisub.openosrs.wintertodt.tasks;

import io.reisub.openosrs.util.Task;
import io.reisub.openosrs.wintertodt.Config;
import io.reisub.openosrs.wintertodt.Wintertodt;
import net.runelite.api.Skill;
import net.runelite.client.plugins.iutils.game.iObject;

import javax.inject.Inject;

import static net.runelite.api.ItemID.*;

public class HandleBank extends Task {
    @Inject
    public Wintertodt plugin;

    @Inject
    public Config config;

    private iObject bankObj;

    @Override
    public boolean validate() {
        bankObj = game.objects().withAction("Bank").nearest();

        return !plugin.isInWintertodtRegion()
                && bank != null
                && game.localPlayer().position().distanceTo(bankObj.position()) < calc.random(5, 7)
                && (!config.openCrates() || !game.inventory().withId(SUPPLY_CRATE).exists())
                && game.inventory().withAction("Eat", "Drink").count() <= 1;
    }

    @Override
    public void execute() {
        if (!bank.isOpen()) {
            bankObj.interact("Bank");
            game.tick();

            game.waitUntil(() -> bank.isOpen(), 15);
        }

        bank.depositExcept(false,
                BRONZE_AXE,
                IRON_AXE,
                STEEL_AXE,
                BLACK_AXE,
                MITHRIL_AXE,
                ADAMANT_AXE,
                RUNE_AXE,
                DRAGON_AXE,
                HAMMER,
                KNIFE,
                TINDERBOX,
                CAKE,
                _23_CAKE,
                SLICE_OF_CAKE,
                SALMON,
                RAW_KARAMBWANJI);
        game.tick();

        int quantity = 10 + (game.baseLevel(Skill.HITPOINTS) - game.modifiedLevel(Skill.HITPOINTS)) / 12;

        bank.withdraw(SALMON, quantity, false);
        game.waitUntil(() -> game.inventory().withAction("Eat", "Drink").count() > 1, 6);
    }

    @Override
    public String getStatus() {
        return "Banking";
    }
}
