package io.reisub.openosrs.wintertodt.tasks;

import io.reisub.openosrs.util.Task;
import io.reisub.openosrs.util.enums.Activity;
import io.reisub.openosrs.wintertodt.Wintertodt;

import javax.inject.Inject;

import static net.runelite.api.NpcID.INCAPACITATED_PYROMANCER;

public class Light extends Task {
    @Inject
    public Wintertodt plugin;

    @Override
    public String getStatus() {
        return "Lighting the brazier";
    }

    @Override
    public boolean validate() {
        if (!plugin.isInWintertodtRegion()) return false;

        int distance = plugin.getCurrentActivity() == Activity.IDLE ? 8 : 2;

        return game.objects().within(distance).withAction("Light").exists()
                && (plugin.getBossHealth() > 0 || plugin.getRespawnTimer() == 0)
                && plugin.getCurrentActivity() != Activity.LIGHTING_BRAZIER
                && !game.npcs().within(6).withId(INCAPACITATED_PYROMANCER).exists();
    }

    @Override
    public void execute() {
        int distance = plugin.getCurrentActivity() == Activity.IDLE ? 8 : 2;

        game.objects().within(distance).withAction("Light").findFirst().ifPresent((brazier) -> {
            brazier.interact("Light");
            game.tick();
        });

        if (distance == 2) {
            game.waitUntil(() -> plugin.getCurrentActivity() == Activity.LIGHTING_BRAZIER || !game.objects().within(distance).withAction("Light").exists(), 3);
        } else {
            game.waitUntil(() -> plugin.getCurrentActivity() == Activity.LIGHTING_BRAZIER || !game.objects().within(distance).withAction("Light").exists(), 6);
        }
    }
}
