package io.reisub.openosrs.wintertodt.tasks;

import com.google.inject.Inject;
import io.reisub.openosrs.util.Task;
import io.reisub.openosrs.util.enums.Activity;
import io.reisub.openosrs.wintertodt.Wintertodt;
import net.runelite.client.plugins.iutils.scene.Position;

public class MoveToBrazier extends Task {
    @Inject
    public Wintertodt plugin;

    @Override
    public String getStatus() {
        return "Moving near brazier";
    }

    @Override
    public boolean validate() {
        if (!plugin.isInWintertodtRegion()) return false;

        if (plugin.isTooCold()
                || (game.localPlayer().position().equals(new Position(1634, 3987, 0)) && plugin.getPreviousActivity() == Activity.FLETCHING)) {
            return true;
        }

        return plugin.getRespawnTimer() > 0
                && !game.localPlayer().position().equals(plugin.getNearestSide().getPositionNearBrazier())
                && !game.localPlayer().isMoving();
    }

    @Override
    public void execute() {
        plugin.setTooCold(false);
        walking.walkTo(plugin.getNearestSide().getPositionNearBrazier());
        game.tick();
    }
}
