package io.reisub.openosrs.wintertodt.tasks;

import io.reisub.openosrs.util.Task;
import io.reisub.openosrs.wintertodt.Config;
import io.reisub.openosrs.wintertodt.Wintertodt;
import net.runelite.client.plugins.iutils.game.iObject;

import javax.inject.Inject;

import static net.runelite.api.ItemID.*;

public class OpenCrates extends Task {
    @Inject
    public Wintertodt plugin;

    @Inject
    public Config config;

    @Override
    public boolean validate() {
        iObject bankObj = game.objects().withAction("Bank").nearest();

        return !plugin.isInWintertodtRegion()
                && game.localPlayer().position().distanceTo(bankObj.position()) < calc.random(5, 7)
                && config.openCrates()
                && game.inventory().withId(SUPPLY_CRATE).exists();
    }

    @Override
    public void execute() {
        game.inventory().withId(SUPPLY_CRATE).forEach((crate) -> {
            crate.interact("Open");
            game.tick();
            game.sleepDelay();
        });

        game.inventory().withId(PYROMANCER_BOOTS, PYROMANCER_GARB, PYROMANCER_HOOD, PYROMANCER_ROBE).forEach((outfit) -> {
            outfit.interact("Wear");
            game.tick(calc.random(2, 4));
            game.sleepDelay();
        });
    }

    @Override
    public String getStatus() {
        return "Opening supply crates";
    }
}
