package io.reisub.openosrs.woodcutter;

import com.google.inject.Provides;
import io.reisub.openosrs.util.CScript;
import io.reisub.openosrs.util.Util;
import io.reisub.openosrs.woodcutter.tasks.Chop;
import io.reisub.openosrs.woodcutter.tasks.Drop;
import lombok.extern.slf4j.Slf4j;
import net.runelite.client.config.ConfigManager;
import net.runelite.client.plugins.PluginDependency;
import net.runelite.client.plugins.PluginDescriptor;
import net.runelite.client.plugins.iutils.iUtils;
import org.pf4j.Extension;

@Extension
@PluginDependency(Util.class)
@PluginDependency(iUtils.class)
@PluginDescriptor(
	name = "Chaos Woodcutter",
	description = "Cuts wood",
	enabledByDefault = false
)
@Slf4j
public class Woodcutter extends CScript {
	@Provides
	Config provideConfig(ConfigManager configManager) {
		return configManager.getConfig(Config.class);
	}

	@Override
	protected void onStart() {
		super.onStart();

		addTask(Chop.class);
		addTask(Drop.class);
	}
}