package io.reisub.openosrs.woodcutter.tasks;

import io.reisub.openosrs.util.Task;
import io.reisub.openosrs.woodcutter.Config;

import javax.inject.Inject;

public class Drop extends Task {
    @Inject
    private Config config;

    @Override
    public String getStatus() {
        return "Dropping";
    }

    @Override
    public boolean validate() {
        return !config.burnLogs()
                && game.inventory().full()
                && game.inventory().withNamePart("logs", "Logs").findAny().isPresent();
    }

    @Override
    public void execute() {
        game.inventory().withNamePart("logs", "Logs").forEach((item -> {
            item.interact("Drop");
            game.sleepDelay();
        }));
    }
}
